//
//  SceneDelegate.m
//  唔即云相册
//
//  Created by 余衡武 on 2021/12/8.
//

#import "SceneDelegate.h"
#import "HWWebViewController.h"
#import "CalculatorViewController.h"
#import "SetUsePWDViewController.h"
#import "GuideViewController.h"
#import "LoginForViewController.h"
#import "UseAccountManage.h"
#import "PlayerViewController.h"
#import "BaseNavigationController.h"
#import "MySetViewController.h"
#import "BuyOrReExchangeViewController.h"
#import "ShortcutManager.h"
#import "SafeForKey.h"

@interface SceneDelegate ()<SetUsePWDViewControllerDelegate,GuideViewControllerDelegate,LoginForViewControllerDelegate>
@property(nonatomic, strong)   CalculatorViewController *calculatorVC;
@property(nonatomic, strong)   HWWebViewController *webVC;
@end

@implementation SceneDelegate


- (void)scene:(UIScene *)scene willConnectToSession:(UISceneSession *)session options:(UISceneConnectionOptions *)connectionOptions {

    if (scene) {
        
        //监听账号异地登陆销通知
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(accountLoginWithOtherDevice:)  name:AccountLoginWithOtherDeviceNotification  object:nil];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(showExchangePhoneVC:)  name:PhoneNoVailTimeNotification  object:nil];
        UIWindowScene *windowScene = (UIWindowScene *)scene;
        self.window = [[UIWindow alloc] initWithWindowScene:windowScene];
        self.window.frame = CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, [UIScreen mainScreen].bounds.size.height);
        // 初始化数据库
        [self initBrowserWindow];
        // 加载主页面
        [self enterMainVCFromScene];

        [self.window makeKeyAndVisible];
    }

}

/** 进入登录界面 - 内部使用 */
- (void)enterLoginVCFromScene {
//    UIViewController *vc = [[UIViewController alloc] init];
//    vc.view.backgroundColor = [UIColor redColor];
//    UINavigationController *nvc = [[UINavigationController alloc] initWithRootViewController:vc];
//    self.window.rootViewController = nvc;
}

/** 主界面 - 内部使用 */
- (void)enterMainVCFromScene {
    
//    GuideViewController
    BOOL haveGuide = [HWDataManager getBoolWithKey:Const_Have_Show_Guide];
    if (haveGuide) {
        ;
    }else {
        GuideViewController *guiDeVC = [[GuideViewController alloc] init];
        guiDeVC.delegate = self;
        self.window.rootViewController = guiDeVC;
        
        return;
    }
    
    NSString *launchAppPWDPath = [self documentPathForAccount:@"" fileFolder:@"LaunchPWD"];
    NSString *str = [[NSString alloc] initWithContentsOfFile:launchAppPWDPath encoding:(NSUTF8StringEncoding) error:nil];
    if (!str || [str isEqualToString:@"0"])
    {
        SetUsePWDViewController *loginVC = [[SetUsePWDViewController alloc] init];
        loginVC.delegate = self;
        self.window.rootViewController = loginVC;
        
        return;
    }
    
    NSDictionary *data = [[UseAccountManage shareInstance] getLoginInfo];
    if (data == nil || ![[data allKeys] containsObject:@"token"]){
        /*判断是否有登录 没有登录时提醒登录*/
        LoginForViewController *loginVC = [[LoginForViewController alloc] init];
        loginVC.delegate = self;
        self.window.rootViewController = loginVC;
        
        return;
    }
    
//    BOOL haveVaildTime = [HWDataManager getBoolWithKey:Const_Have_No_VaildTime];
//    if (haveVaildTime == YES){/*无有效时间*/
//        [self showExchangePhoneVC];
//    }
    
    PlayerViewController *playerRootVC = [[PlayerViewController alloc] init];
    BaseNavigationController *playerNav = [[BaseNavigationController alloc] initWithRootViewController:playerRootVC];
    self.window.rootViewController = playerNav;
    return;
    
//
//    MySetViewController *playerRootVC = [[MySetViewController alloc] init];
//    BaseNavigationController *playerNav = [[BaseNavigationController alloc] initWithRootViewController:playerRootVC];
//    self.window.rootViewController = playerNav;
}

- (void)showExchangePhoneVC:(NSNotification*)not{
    NSDictionary *dict = not.userInfo;
    NSArray *privilegeList = [dict objectForKey:@"privilegeList"];
    
    /*0开通  3续费*/
    NSInteger whetherPhoneStatus = [[dict objectForKey:@"whetherPhoneStatus"] integerValue];
    /*已过期，无有效使用时长 直接加载购买续费界面*/
    BuyOrReExchangeViewController *buyOrReExchangeVC = [[BuyOrReExchangeViewController alloc] init];
    buyOrReExchangeVC.privilegeList = privilegeList;
    if (0 == whetherPhoneStatus){
        buyOrReExchangeVC.buyOrExchange = 0;
    }else if (3 == whetherPhoneStatus){
        NSInteger expirationReminder = [[dict safeStringForKey:@"expirationReminder"] integerValue];
        buyOrReExchangeVC.buyOrExchange = 1;
        buyOrReExchangeVC.expirationReminder = expirationReminder;
    }
    
    BaseNavigationController *buyOrReExchangeNav = [[BaseNavigationController alloc] initWithRootViewController:buyOrReExchangeVC];
    self.window.rootViewController = buyOrReExchangeNav;
    return;
}

- (void)setPwdOk{
    [self enterMainVCFromScene];
    
//    NSArray *dataArray = [BaseModel bg_findAll:DB_BrowserWindows_TableName];
//    
//    if (dataArray.count == 0) { // 浏览器没有窗口
//        // 加载首页
//        HWWebViewController *vc = [[HWWebViewController alloc] init];
//        vc.webUrl = Const_HomeUrl;
//        UINavigationController *nvc = [[UINavigationController alloc] initWithRootViewController:vc];
//        self.window.rootViewController = nvc;
//        
//    }else {
//        // 浏览器当前窗口索引ID
//        NSInteger ID = [HWDataManager getIntegerWithKey:BrowserWindowsCurrentID];
//        NSString *where = [NSString stringWithFormat:@"where %@=%ld",bg_sqlKey(@"ID"),(long)ID];
//        NSArray* finfAlls = [BaseModel bg_find:DB_BrowserWindows_TableName where:where];
//        BaseModel *model = finfAlls.firstObject;
//        
//        // 加载网页
//        HWWebViewController *vc = [[HWWebViewController alloc] init];
//        vc.webUrl = model.webUrl;
//        UINavigationController *nvc = [[UINavigationController alloc] initWithRootViewController:vc];
//        self.window.rootViewController = nvc;
//    }
}

/** 登录界面 - 外部使用*/
+ (void)enterLoginVC {
//    SetPWDViewController *vc = [[SetPWDViewController alloc] init];
//    UINavigationController *nvc = [[UINavigationController alloc] initWithRootViewController:vc];
//    UIWindow *keyWindow = [iTools getKeyWindow];
//    keyWindow.rootViewController = nvc;
}

/** 主界面 - 外部使用 */
+ (void)enterMainVC {
//    AlbumHomeViewController *vc = [[AlbumHomeViewController alloc] init];
//    UINavigationController *nvc = [[UINavigationController alloc] initWithRootViewController:vc];
//    UIWindow *keyWindow = [iTools getKeyWindow];
//    keyWindow.rootViewController = nvc;
}

- (void)sceneDidDisconnect:(UIScene *)scene {
    
}


- (void)sceneDidBecomeActive:(UIScene *)scene {
    BOOL haveGuide = [HWDataManager getBoolWithKey:Const_Have_Show_Guide];
    if (haveGuide) {
        ;
    }else {
        
        return;
    }
    [self showCalculatorVC];
}


- (void)sceneWillResignActive:(UIScene *)scene {
    BOOL haveGuide = [HWDataManager getBoolWithKey:Const_Have_Show_Guide];
    if (haveGuide) {
        ;
    }else {
        
        return;
    }
    [self showCalculatorVC];
}


- (void)sceneWillEnterForeground:(UIScene *)scene {

}


- (void)sceneDidEnterBackground:(UIScene *)scene {
    BOOL haveGuide = [HWDataManager getBoolWithKey:Const_Have_Show_Guide];
    if (haveGuide) {
        ;
    }else {
        
        return;
    }
    [self showCalculatorVC];
}

#pragma mark 初始化数据库-DB_BrowserWindows_TableName
- (void)initBrowserWindow {
    
    // 浏览器当前所有窗口
    NSArray *dataArray = [BaseModel bg_findAll:DB_BrowserWindows_TableName];

    // 浏览器当前窗口索引ID
    NSInteger ID = [HWDataManager getIntegerWithKey:BrowserWindowsCurrentID];
    NSString *IDValue = [NSString stringWithFormat:@"%ld", ID];
    NSString *where = [NSString stringWithFormat:@"where %@=%@",bg_sqlKey(@"ID"),bg_sqlValue(IDValue)];
    NSArray *modelArr = [BaseModel bg_find:DB_BrowserWindows_TableName where:where];
    
    if (dataArray.count == 0) { // 浏览器没有窗口
        
        BaseModel *model = [[BaseModel alloc] init];
        model.ID = 0;
        model.name = @"主页";
//        model.iconFile = imageUrl;
        model.webUrl = Const_HomeUrl;
        
        // 写入数据库
        model.bg_tableName = DB_BrowserWindows_TableName;
        [model bg_saveOrUpdateAsync:^(BOOL isSuccess) {
            HLog(@"BaseModel写入：%@", isSuccess ? @"成功":@"失败");
        }];
        
        // 浏览器当前窗口索引ID
        [HWDataManager setIntegerWithKey:BrowserWindowsCurrentID value:0];
        
    }else if (modelArr.count == 0) { // 新建窗口

        BaseModel *model = [[BaseModel alloc] init];
        model.ID = ID;
        model.name = @"主页";
//        model.iconFile = imageUrl;
        model.webUrl = Const_HomeUrl;
        
        // 写入数据库
        model.bg_tableName = DB_BrowserWindows_TableName;
        [model bg_saveOrUpdateAsync:^(BOOL isSuccess) {
            HLog(@"BaseModel写入：%@", isSuccess ? @"成功":@"失败");
        }];
        
    }else { // 更新窗口数据
        // 浏览器当前窗口索引ID
//        NSInteger ID = [HWDataManager getIntegerWithKey:BrowserWindowsCurrentID];
//        
//        BaseModel *model = [[BaseModel alloc] init];
//        model.ID = ID;
//        model.name = @"主页";
////        model.iconFile = imageUrl;
//        model.webUrl = Const_HomeUrl;
//        
//        // 更新数据库
//        model.bg_tableName = DB_BrowserWindows_TableName;
//        [model bg_saveOrUpdateAsync:^(BOOL isSuccess) {
//            HLog(@"BaseModel更新： %@", isSuccess ? @"成功":@"失败");
//        }];
    }
}


#pragma mark 获取当前屏幕的截图
//- (UIImage *)getScreenShotImage {
//    CGSize size = [UIScreen mainScreen].bounds.size;
//    CGFloat scale = [UIScreen mainScreen].scale;
//    UIGraphicsBeginImageContextWithOptions(size, YES, scale);
//    [self.window.layer renderInContext:UIGraphicsGetCurrentContext()];
//    UIImage * image = UIGraphicsGetImageFromCurrentImageContext();
//    UIGraphicsEndImageContext();
//    return image;
//}

#pragma mark 计算器伪装视图
/*CalculatorViewController*/
- (void)showCalculatorVC{
    /*无有效时长直接返回不加载任何加密界面*/
    
    NSString *launchAppPWDPath = [self documentPathForAccount:@"" fileFolder:@"LaunchPWD"];
    NSString *str = [[NSString alloc] initWithContentsOfFile:launchAppPWDPath encoding:(NSUTF8StringEncoding) error:nil];
    if (!str || [str isEqualToString:@""])
    {
        return;
    }
    
    BOOL haveOpenMask = [HWDataManager getBoolWithKey:Const_Mask_View_Open];
    if (!haveOpenMask){
        return;
    }
    
    BOOL haveVaildTime = [HWDataManager getBoolWithKey:Const_Have_No_VaildTime];
    if (haveVaildTime == YES){/*无有效时间*/
        return;
    }
    
    NSInteger maskModel = [HWDataManager getIntegerWithKey:Const_Mask_View_Model];
    if (maskModel == 2){
        /*浏览器*/
        [self closeCalculatorVC];
        _webVC = [[HWWebViewController alloc] init];
        _webVC.pwd = str;
        _webVC.webUrl = @"https://baidu.com";
        [self.window addSubview:_webVC.view];
    }else{
        /*计算器*/
        [self closeCalculatorVC];
        _calculatorVC = [[CalculatorViewController alloc] init];
        _calculatorVC.pwd = str;
        [self.window addSubview:_calculatorVC.view];
    }
}

- (void)closeCalculatorVC{
    if (_calculatorVC){
        [_calculatorVC.view removeFromSuperview];
    }
    
    /*浏览器*/
    if (_webVC){
        [_webVC.view removeFromSuperview];
    }
}

- (NSString *)documentPathForAccount:(NSString *)account fileFolder:(NSString *)fileFolder {
    
    NSString *path = DocumentPath;
    if (account.length != 0) {
        path = [NSString stringWithFormat:@"%@/%@/",DocumentPath,account];
    }
        
    if ([fileFolder containsString:@"/"]) {
        NSString *path1 = [path stringByAppendingPathComponent:fileFolder];
        path1 = [path1 stringByDeletingLastPathComponent];
        NSError *error;
        if (![[NSFileManager defaultManager] fileExistsAtPath:path1]) {
            [[NSFileManager defaultManager] createDirectoryAtPath:path1 withIntermediateDirectories:YES attributes:nil error:&error];
        }
    }else{
        NSError *error;
        if (![[NSFileManager defaultManager] fileExistsAtPath:path]) {
            [[NSFileManager defaultManager] createDirectoryAtPath:path withIntermediateDirectories:YES attributes:nil error:&error];
        }
    }
    
    return [path stringByAppendingPathComponent:fileFolder];
}

- (void)startUseBtnBePressed{
    [self enterMainVCFromScene];
//    NSString *launchAppPWDPath = [self documentPathForAccount:@"" fileFolder:@"LaunchPWD"];
//    NSString *str = [[NSString alloc] initWithContentsOfFile:launchAppPWDPath encoding:(NSUTF8StringEncoding) error:nil];
//    if (!str || [str isEqualToString:@"0"])
//    {
//        SetUsePWDViewController *loginVC = [[SetUsePWDViewController alloc] init];
//        loginVC.delegate = self;
//        self.window.rootViewController = loginVC;
//
//        return;
//    }
//
//    NSArray *dataArray = [BaseModel bg_findAll:DB_BrowserWindows_TableName];
//
//    if (dataArray.count == 0) { // 浏览器没有窗口
//        // 加载首页
//        HWWebViewController *vc = [[HWWebViewController alloc] init];
//        vc.webUrl = Const_HomeUrl;
//        UINavigationController *nvc = [[UINavigationController alloc] initWithRootViewController:vc];
//        self.window.rootViewController = nvc;
//
//    }else {
//        // 浏览器当前窗口索引ID
//        NSInteger ID = [HWDataManager getIntegerWithKey:BrowserWindowsCurrentID];
//        NSString *where = [NSString stringWithFormat:@"where %@=%ld",bg_sqlKey(@"ID"),(long)ID];
//        NSArray* finfAlls = [BaseModel bg_find:DB_BrowserWindows_TableName where:where];
//        BaseModel *model = finfAlls.firstObject;
//
//        // 加载网页
//        HWWebViewController *vc = [[HWWebViewController alloc] init];
//        vc.webUrl = model.webUrl;
//        UINavigationController *nvc = [[UINavigationController alloc] initWithRootViewController:vc];
//        self.window.rootViewController = nvc;
//    }
}

- (void)loginOk{
    [self enterMainVCFromScene];
}


//static BOOL  isFirstTimeShowAccountLoginWithOtherDevice = YES;
- (void)accountLoginWithOtherDevice:(NSNotification*)not {
    UIViewController *currentVC = [[ShortcutManager shareInstance] findCurrentShowingViewController];
    
    NSDictionary *dict = not.userInfo;
    NSString *msg = dict[@"msg"];
    if (msg.length == 0) {
        msg = @"设备已在别处登录";
    }
    
    NSDictionary *dictLogin = [[UseAccountManage shareInstance] getLoginInfo];
    if (dictLogin.allKeys.count == 0) { // 已经被清掉了
        return;
    }
    
    /*设备已在别处登录*/
    [self initAlertWithTitle:nil message:msg sureActionBlock:^(UIAlertController * _Nonnull alertView) {
        [[UseAccountManage shareInstance] logout];
        // 退出登录
        [self enterMainVCFromScene];
    }];
}

-(void)initAlertWithTitle:(NSString *_Nullable)title message:(NSString *)message sureActionBlock:(sureActionBlock)sureActionBlock {
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:title message:message preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:NSLocalizedString(@"other_comment_ok",nil) style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
        
        sureActionBlock(alertController);
    }];
    [alertController addAction:cancelAction];
    
    // 弹窗边框
    UIView *subview = alertController.view.subviews.firstObject;
    UIView *alertContentView = subview.subviews.firstObject;
    alertContentView.layer.cornerRadius = 10;
//                alertContentView.layer.masksToBounds = YES;
    alertContentView.layer.shadowColor = [UIColor colorWithRed:30/255.0 green:32/255.0 blue:34/255.0 alpha:1.0].CGColor;
    alertContentView.layer.shadowOffset = CGSizeMake(0,0);
    alertContentView.layer.shadowOpacity = 1;
    alertContentView.layer.shadowRadius = 7;
    // 弹窗背景颜色
    if (@available(iOS 13.0, *)) {
        alertController.overrideUserInterfaceStyle = UIUserInterfaceStyleDark;
    }
    
    UIViewController *currentVC = [[ShortcutManager shareInstance] findCurrentShowingViewController];
    [currentVC presentViewController:alertController animated:YES completion:nil];
//    [self presentViewController:alertController animated:YES completion:nil];
}

@end
