//
//  BuyOrReExchangeViewController.m
//  隐私保护
//
//  Created by APPLE on 2023/8/23.
//

#import "BuyOrReExchangeViewController.h"
#import <Masonry.h>
#import "VIPFunctView.h"
#import "CellWithBtnView.h"
#import "CustomerWebViewController.h"
#import "UseAccountManage.h"
#import "iPhone.h"
#import "MySetViewController.h"
#import "BuyVIPViewController.h"

@interface BuyOrReExchangeViewController ()
{
    VIPFunctView *vipFunctView;
    CellWithBtnView *upCell;
    CellWithBtnView *downCell;
}

@end

@implementation BuyOrReExchangeViewController
@synthesize privilegeList;
@synthesize buyOrExchange;
@synthesize expirationReminder;

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    [self drawAnyView];
}


- (void)drawAnyView{
    [self.view setBackgroundColor:HWF5F7FAColor];
    
    [self.toolBar setHidden:YES];
    [self.navigationBar setHidden:YES];
    
    UIImageView *bgImageView = [[UIImageView alloc] init];
    [bgImageView setImage:[UIImage imageNamed:@"buy_home_bj"]];
    [self.view addSubview:bgImageView];
    [bgImageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.top.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
    }];
    
    UILabel *leftUpLabel = [[UILabel alloc] init];
    [leftUpLabel setText:NSLocalizedString(@"buy_home_private_title",nil)];
    [leftUpLabel setTextColor:HW0A132BColor];
    [leftUpLabel setFont:[UIFont boldSystemFontOfSize:18.f]];
    [self.view addSubview:leftUpLabel];
    [leftUpLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(21.f);
        make.right.mas_equalTo(-100.f);
        make.top.mas_equalTo(17.f + H_STATE_BAR);
        make.height.mas_equalTo(24.f);
    }];
    
    /*设置按钮*/
    UIButton *setBtn = [[UIButton alloc] init];
    [setBtn setBackgroundColor:[UIColor clearColor]];
    [setBtn setImage:[UIImage imageNamed:@"right_up_set"] forState:(UIControlStateNormal)];
    [self.view addSubview:setBtn];
    [setBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.mas_equalTo(-10.f);
        make.centerY.equalTo(leftUpLabel.mas_centerY);
        make.height.mas_equalTo(38.f);
        make.width.mas_equalTo(38.f);
    }];
    
    [setBtn setImageEdgeInsets:(UIEdgeInsetsMake(10, 10, 10, 10))];
    [setBtn addTarget:self
               action:@selector(setBtnPressed)
     forControlEvents:(UIControlEventTouchUpInside)];
    
    /*右上角图片*/
    UIImageView *upRightImageView = [[UIImageView alloc] init];
    [upRightImageView setBackgroundColor:[UIColor clearColor]];
    [upRightImageView setImage:[UIImage imageNamed:@"buy_home_right_up"]];
    [self.view addSubview:upRightImageView];
    [upRightImageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.mas_equalTo(0);
        make.top.equalTo(setBtn.mas_bottom).offset(29.f);
        make.width.mas_equalTo(187.f);
        make.height.mas_equalTo(226.f);
    }];
    
    /*大标题*/
    UILabel *bigLabel = [[UILabel alloc] init];
    [bigLabel setNumberOfLines:0];
    [bigLabel setTextColor:HW0A132BColor];
    [bigLabel setText:NSLocalizedString(@"buy_home_big_title",nil)];
    [bigLabel setFont:[UIFont boldSystemFontOfSize:28.f]];
    [self.view addSubview:bigLabel];
    [bigLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(28.f);
        make.top.equalTo(leftUpLabel.mas_bottom).offset(69.f);
        make.right.mas_equalTo(-100.f);
        make.height.mas_equalTo(72.f);
    }];
    
    /*下方红字*/
    UILabel *warLabel = [[UILabel alloc] init];
    [warLabel setNumberOfLines:0];
    [warLabel setTextColor:HWDD4E4EColor];
    [warLabel setText:NSLocalizedString(@"buy_home_war_title",nil)];
    [warLabel setFont:[UIFont systemFontOfSize:12.f]];
    [self.view addSubview:warLabel];
    [warLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(28.f);
        make.top.equalTo(bigLabel.mas_bottom).offset(8.f);
        make.right.mas_equalTo(-100.f);
        make.height.mas_equalTo(17.f);
    }];
    
    /*VIP视图*/
    vipFunctView = [[VIPFunctView alloc] initWithList:privilegeList];
    [self.view addSubview:vipFunctView];
    [vipFunctView setBackgroundColor:[UIColor clearColor]];
    [vipFunctView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(19.f);
        make.top.equalTo(upRightImageView.mas_top).offset(207);
        make.right.mas_equalTo(-19.f);
        make.height.mas_equalTo(210.f);
    }];
    
    /*开通或者续费会员*/
    upCell = [[CellWithBtnView alloc] init];
    [upCell setBackgroundColor:[UIColor whiteColor]];
    [self.view addSubview:upCell];
    [upCell mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(19.f);
        make.top.equalTo(vipFunctView.mas_bottom).offset(16);
        make.right.mas_equalTo(-19.f);
        make.height.mas_equalTo(72.f);
    }];
    [upCell.layer setCornerRadius:8];
    
    if (buyOrExchange == 0){/*开通*/
        [upCell.topLabel setText:NSLocalizedString(@"buy_home_cell_get_vip",nil)];
        [upCell.downLabel setText:NSLocalizedString(@"buy_home_cell_get_vip_detail",nil)];
        [upCell.rightBtn setTitle:NSLocalizedString(@"buy_home_cell_get_vip_do",nil) forState:(UIControlStateNormal)];
    }else{/*续费*/
//        expirationReminder
        [upCell.topLabel setText:NSLocalizedString(@"buy_home_cell_exchange_vip",nil)];
        
        NSString *leftStr = NSLocalizedString(@"buy_vip_buy_dtat_will_lost",nil);
        NSString *middleStr = [NSString stringWithFormat:@"%ld",expirationReminder];
        NSString *rightStr = NSLocalizedString(@"buy_vip_package_detail_day",nil);
        NSString *showStr = [[leftStr stringByAppendingString:middleStr] stringByAppendingString:rightStr];
        NSMutableAttributedString *string = [[NSMutableAttributedString alloc] initWithString:showStr attributes: @{NSForegroundColorAttributeName:HW666666Color}];
        
        [string addAttributes:@{NSForegroundColorAttributeName:HWDD4E4EColor} range:NSMakeRange(leftStr.length, middleStr.length)];
        [upCell.downLabel setAttributedText:string];
        [upCell.rightBtn setTitle:NSLocalizedString(@"buy_home_cell_exchange_vip_do",nil) forState:(UIControlStateNormal)];
    }
    
    [upCell.rightBtn addTarget:self
                        action:@selector(toBuyVIP) forControlEvents:(UIControlEventTouchUpInside)];
    
    downCell = [[CellWithBtnView alloc] init];
    [downCell setBackgroundColor:[UIColor whiteColor]];
    [self.view addSubview:downCell];
    [downCell mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(19.f);
        make.top.equalTo(upCell.mas_bottom).offset(8);
        make.right.mas_equalTo(-19.f);
        make.height.mas_equalTo(72.f);
    }];
    [downCell.layer setCornerRadius:8];
    [downCell.topLabel setText:NSLocalizedString(@"buy_home_cell_get_vip_free_get",nil)];
    [downCell.downLabel setText:NSLocalizedString(@"buy_home_cell_get_vip_invite_detail",nil)];
    [downCell.rightBtn setTitle:NSLocalizedString(@"buy_home_cell_get_vip_invite",nil) forState:(UIControlStateNormal)];
    [downCell.rightBtn addTarget:self
                        action:@selector(toInviteFriend) forControlEvents:(UIControlEventTouchUpInside)];
}

- (void)setBtnPressed{
    HLog(@"\n---右上角按钮点击-");
    MySetViewController *nextVC = [[MySetViewController alloc] init];
    [self.navigationController pushViewController:nextVC animated:YES];
}

- (void)toBuyVIP{
    BuyVIPViewController *nextVC = [[BuyVIPViewController alloc] init];
    [self.navigationController pushViewController:nextVC animated:YES];
}

- (void)toInviteFriend{
    CustomerWebViewController *vc = [[CustomerWebViewController alloc] init];
    vc.needHidenNav = YES;
    NSDictionary *dictLogin = [[UseAccountManage shareInstance] getLoginInfo];
    if (dictLogin && [[dictLogin allKeys] containsObject:@"token"])
    {
        NSString *tokenStr = [dictLogin objectForKey:@"token"];
        NSString *url = [NSString stringWithFormat:@"http://192.168.11.32:11180/cloud/privacy/#/pages/invitation/index?token=%@&iosVersionNumber=%@", tokenStr,[iPhone appVersion]];
        vc.webUrl = url;
        [self.navigationController pushViewController:vc animated:YES];
    }
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
