//
//  VIPFunctView.m
//  隐私保护
//
//  Created by APPLE on 2023/8/24.
//

#import "VIPFunctView.h"
#import <Masonry.h>

@interface VIPFunctView(){

}

@end

@implementation VIPFunctView


- (id)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    
//    [self drawAnyView];
    
    return self;
}

- (id)initWithList:(NSArray *)privilegeList{
    self = [super init];
    
    [self drawAnyViewWithList:privilegeList];
    
    return self;
}

- (void)drawAnyViewWithList:(NSArray *)privilegeList{
    /*上方背景*/
    UIImageView *upBGView = [[UIImageView alloc] init];
    [upBGView setBackgroundColor:[UIColor clearColor]];
    [upBGView setImage:[UIImage imageNamed:@"buy_home_fun_bg"]];
    [self addSubview:upBGView];
    [upBGView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.top.mas_equalTo(22);
        make.height.mas_equalTo(83);
    }];
    
    /*上方文字*/
    UILabel *topLabel = [[UILabel alloc] init];
    [topLabel setFont:[UIFont boldSystemFontOfSize:16.f]];
    [topLabel setTextColor:HW0A132BColor];
    [topLabel setText:NSLocalizedString(@"buy_home_fun_title",nil)];
    [topLabel setTextAlignment:(NSTextAlignmentCenter)];
    [upBGView addSubview:topLabel];
    [topLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.top.mas_equalTo(20);
        make.height.mas_equalTo(22);
    }];
    
    /*上方图标*/
    UIImageView *upFlagView = [[UIImageView alloc] init];
    [upFlagView setBackgroundColor:[UIColor clearColor]];
    [upFlagView setImage:[UIImage imageNamed:@"buy_home_fun_up_flag"]];
    [self addSubview:upFlagView];
    [upFlagView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(20);
        make.width.mas_equalTo(64);
        make.top.mas_equalTo(0);
        make.height.mas_equalTo(29);
    }];
    
    /*下方视图背景*/
    UIView *downBGView = [[UIView alloc] init];
    [downBGView setBackgroundColor:HWFFFFFFColor];
    [downBGView.layer setCornerRadius:8.f];
    [self addSubview:downBGView];
    [downBGView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
        make.height.mas_equalTo(138);
    }];
    
    /*绘制标签*/
    for (NSInteger nFori = 0; nFori < privilegeList.count; nFori++) {
        UIButton *flagBtn = [[UIButton alloc] init];
        [flagBtn setImage:[UIImage imageNamed:@"buy_home_flag_fun"] forState:(UIControlStateNormal)];
        [flagBtn setTitleColor:HW666666Color forState:(UIControlStateNormal)];
        [flagBtn.titleLabel setFont:[UIFont systemFontOfSize:12.f]];
        [flagBtn setTitle:privilegeList[nFori] forState:(UIControlStateNormal)];
        [flagBtn setContentHorizontalAlignment:(UIControlContentHorizontalAlignmentLeft)];
        [downBGView addSubview:flagBtn];
        
        /*计算位置*/
        NSInteger x_place = nFori%2;
        NSInteger y_palce = nFori/2;
        [flagBtn mas_makeConstraints:^(MASConstraintMaker *make) {
            if (x_place == 0){
                make.left.mas_equalTo(28);
            }else{
                make.left.equalTo(downBGView.mas_centerX).offset(28);
            }
            make.width.mas_equalTo(140);
            make.top.mas_equalTo(24 + y_palce*(18.f+18.f));
            make.height.mas_equalTo(18);
        }];
    }
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
