//
//  PackageListScrollView.m
//  VclustersGemini
//
//  Created by APPLE on 2020/4/18.
//  Copyright © 2020 APPLE. All rights reserved.
//

#import "PackageListScrollView.h"
#import "packDetailBtn.h"

@interface PackageListScrollView(){
    
}
@end

@implementation PackageListScrollView
@synthesize packageModelAry;
@synthesize selectIndex;

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/
 - (BOOL)gestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldRecognizeSimultaneouslyWithGestureRecognizer:(UIGestureRecognizer *)otherGestureRecognizer
 {
     if (gestureRecognizer.state != 0) {
         return YES;
     } else {
         return NO;
     }
 }


- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    
    if (self)
    {
        self.delaysContentTouches = NO;
    }
    return self;
}


- (BOOL)touchesShouldCancelInContentView:(UIView*)view {
    if ([view isKindOfClass:UIButton.class]) {
        return YES;
    }

    return[super touchesShouldCancelInContentView:view];
}



//-(UIView *)hitTest:(CGPoint)point withEvent:(UIEvent *)event
//{
//    UIView *view = [super hitTest:point withEvent:event];
//    return view;
//}

- (void)setPackageModelAry:(NSMutableArray *)packageModelAry{
    self->packageModelAry = packageModelAry;
    
    for (UIView *subView in [self subviews]) {
        [subView removeFromSuperview];
    }
    
    [self testCellNumber:packageModelAry.count];
}


- (void)testCellNumber:(NSInteger)number{
    for (NSInteger nFori = 0; nFori < number; nFori++) {
        NSInteger x_index = nFori%2;
        NSInteger y_index = nFori/2;
        CGFloat w_btn = (SCREEN_W - 2*15.f - 15.f)/2.f;
        
        packDetailBtn *tempView = [[packDetailBtn alloc] initWithFrame:(CGRectMake(x_index*(w_btn + 15.f), 16.f + y_index*(113.f + 16.f), w_btn, 113.f))];
        tempView.tag = 12345+nFori;
        tempView.model = [self->packageModelAry objectAtIndex:nFori];
        [self addSubview:tempView];
        [tempView.layer setCornerRadius:8.f];
        tempView.clipsToBounds = YES;
        
        [tempView addTarget:self
                     action:@selector(packageSelect:)
           forControlEvents:(UIControlEventTouchUpInside)];
        
        if (nFori == 0){
            [tempView setSelected:YES];
            self.selectIndex = 0;
        }else{
            [tempView setSelected:NO];
        }
        
        if (nFori == number-1){
            UIView *hidenView = [[UIView alloc] init];
            [hidenView setBackgroundColor:[UIColor clearColor]];
            [self addSubview:hidenView];
            [hidenView mas_makeConstraints:^(MASConstraintMaker *make) {
                make.left.mas_equalTo(0);
                make.top.equalTo(tempView.mas_bottom).offset(0);
                make.width.mas_equalTo(SCREEN_W - 3*15.f);
                make.height.mas_equalTo(16);
                make.bottom.equalTo(self.mas_bottom).offset(0);
            }];
        }
    }
    
    [self mas_updateConstraints:^(MASConstraintMaker *make) {
        if (number <= 2){
            make.height.mas_equalTo(145);
        }else if (number <= 4){
            make.height.mas_equalTo(145 + 113.f + 16.f);
        }else{
            make.height.mas_equalTo(145 + 113.f + 16.f + 113.f/2.f);
        }
    }];
}

- (void)packageSelect:(id)sender{
    UIButton *selectBtn = (UIButton *)sender;
    selectIndex = selectBtn.tag - 12345;
    
    HLog(@"\n---你选中了第%ld个套餐---",selectIndex);
    
    for (UIButton *subView in [self subviews]) {
        
        if ([subView isKindOfClass:[UIButton class]]){
            [subView setSelected:NO];
        }
    }
    
    [selectBtn setSelected:YES];
}

@end
