//
//  PayTypeView.m
//  隐私保护
//
//  Created by APPLE on 2023/8/28.
//

#import "PayTypeView.h"
#import <Masonry.h>

@interface PayTypeView(){
    UIButton *wxPaySelectFlagBtn;
    UIButton *airPaySelectFlagBtn;
}

@end

@implementation PayTypeView
@synthesize wxPayBtn;
@synthesize airPayBtn;
@synthesize selectPayType;

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (id)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    
    [self drawAnyView];
    
    return self;
}

- (void)drawAnyView{
    wxPayBtn = [[UIButton alloc] init];
    [self addSubview:wxPayBtn];
    [wxPayBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.top.mas_equalTo(0);
        make.height.mas_equalTo(60);
    }];
    [wxPayBtn setImage:[UIImage imageNamed:@"icon_wechat_pay"] forState:(UIControlStateNormal)];
    [wxPayBtn setImageEdgeInsets:(UIEdgeInsetsMake(0, 10, 0, 10))];
    [wxPayBtn setTitle:@"微信支付" forState:(UIControlStateNormal)];
    [wxPayBtn setTitleEdgeInsets:(UIEdgeInsetsMake(0, 13, 0, 10))];
    [wxPayBtn setTitleColor:HW0A132BColor forState:(UIControlStateNormal)];
    [wxPayBtn.titleLabel setFont:[UIFont systemFontOfSize:13.f]];
    [wxPayBtn setContentHorizontalAlignment:(UIControlContentHorizontalAlignmentLeft)];
    [wxPayBtn addTarget:self
                 action:@selector(wxPayBtnPressed)
       forControlEvents:(UIControlEventTouchUpInside)];
    
    wxPaySelectFlagBtn = [[UIButton alloc] init];
    [wxPaySelectFlagBtn setImage:[UIImage imageNamed:@"buy_type_disselect"] forState:(UIControlStateNormal)];
    [wxPaySelectFlagBtn setImage:[UIImage imageNamed:@"buy_type_selected"] forState:(UIControlStateSelected)];
    [wxPaySelectFlagBtn setSelected:YES];
    [wxPayBtn addSubview:wxPaySelectFlagBtn];
    [wxPaySelectFlagBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(16.f);
        make.right.mas_equalTo(-15);
        make.width.mas_equalTo(28.f);
        make.height.mas_equalTo(28.f);
    }];
    
    UIView *line = [[UIView alloc] init];
    [line setBackgroundColor:HW979797Color10];
    [self addSubview:line];
    [line mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(15);
        make.right.mas_equalTo(-15);
        make.centerY.equalTo(self.mas_centerY);
        make.height.mas_equalTo(1);
    }];
    
//    icon_air_pay
    airPayBtn = [[UIButton alloc] init];
    [self addSubview:airPayBtn];
    [airPayBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
        make.height.mas_equalTo(60);
    }];
    [airPayBtn setImage:[UIImage imageNamed:@"icon_air_pay"] forState:(UIControlStateNormal)];
    [airPayBtn setImageEdgeInsets:(UIEdgeInsetsMake(0, 10, 0, 10))];
    [airPayBtn setTitleEdgeInsets:(UIEdgeInsetsMake(0, 13, 0, 10))];
    [airPayBtn setTitle:@"支付宝" forState:(UIControlStateNormal)];
    [airPayBtn setTitleColor:HW0A132BColor forState:(UIControlStateNormal)];
    [airPayBtn.titleLabel setFont:[UIFont systemFontOfSize:13.f]];
    [airPayBtn setContentHorizontalAlignment:(UIControlContentHorizontalAlignmentLeft)];
    [airPayBtn addTarget:self
                 action:@selector(airPayBtnPressed)
       forControlEvents:(UIControlEventTouchUpInside)];
    
    airPaySelectFlagBtn = [[UIButton alloc] init];
    [airPaySelectFlagBtn setImage:[UIImage imageNamed:@"buy_type_disselect"] forState:(UIControlStateNormal)];
    [airPaySelectFlagBtn setImage:[UIImage imageNamed:@"buy_type_selected"] forState:(UIControlStateSelected)];
    [airPaySelectFlagBtn setSelected:NO];
    [airPayBtn addSubview:airPaySelectFlagBtn];
    [airPaySelectFlagBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(16.f);
        make.right.mas_equalTo(-15);
        make.width.mas_equalTo(28.f);
        make.height.mas_equalTo(28.f);
    }];
    
    self.selectPayType = 0;
}

- (void)setSelectPayType:(NSInteger)selectPayType{
    self->selectPayType = selectPayType;
    
    /*改变图标*/
    if (selectPayType == 0){
        [wxPaySelectFlagBtn setSelected:YES];
        [airPaySelectFlagBtn setSelected:NO];
    }else{
        [wxPaySelectFlagBtn setSelected:NO];
        [airPaySelectFlagBtn setSelected:YES];
    }
}

- (void)wxPayBtnPressed{
    self.selectPayType = 0;
}

- (void)airPayBtnPressed{
    self.selectPayType = 1;
}

@end
