//
//  packDetailBtn.m
//  隐私保护
//
//  Created by APPLE on 2023/8/28.
//

#import "packDetailBtn.h"
#import <Masonry.h>

@interface packDetailBtn(){
    UILabel *actPiceLabel;
    UILabel *orgPiceLabel;
    UILabel *vailTimeLabel;
}

@end

@implementation packDetailBtn
@synthesize model;

- (id)init{
    self = [super init];
    
    [self drawAnyView];
    
    return self;
}

- (id)initWithFrame:(CGRect)frame{
    self= [super initWithFrame:frame];
    
    [self drawAnyView];
    
    return self;
}

- (void)drawAnyView{
    actPiceLabel = [[UILabel alloc] init];
    [actPiceLabel setTextColor:HWDD4E4EColor];
    [actPiceLabel setTextAlignment:(NSTextAlignmentRight)];
    [self addSubview:actPiceLabel];
    [actPiceLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.equalTo(self.mas_centerX).offset(25);
        make.top.mas_equalTo(20.f);
        make.height.mas_equalTo(50.f);
    }];
    
    orgPiceLabel = [[UILabel alloc] init];
    [orgPiceLabel setTextColor:HW666666Color];
    [self addSubview:orgPiceLabel];
    [orgPiceLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(actPiceLabel.mas_right).offset(5.f);
        make.top.mas_equalTo(44.f);
        make.height.mas_equalTo(18.f);
    }];
    
    vailTimeLabel = [[UILabel alloc] init];
    [vailTimeLabel setTextColor:HW0A132BColor];
    [vailTimeLabel setTextAlignment:(NSTextAlignmentCenter)];
    [self addSubview:vailTimeLabel];
    [vailTimeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(20.f);
        make.right.mas_equalTo(-20.f);
        make.bottom.mas_equalTo(-20.f);
        make.height.mas_equalTo(18.f);
    }];
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (void)setSelected:(BOOL)selected{
    [super setSelected:selected];
    
    if (selected){
        self.layer.borderWidth = 2;
        self.layer.borderColor = HW13B2EBColor.CGColor;
        self.backgroundColor = HWE7F2F8Color;
    }else{
        self.backgroundColor = HWFFFFFFColor;
        self.layer.borderWidth = 0;
        self.layer.borderColor = HW13B2EBColor.CGColor;
    }
}

- (void)setModel:(PhonePackageModel *)model{
    self->model = model;
    
    /*真实价格*/
    NSString *leftStr0 = @"￥";
    NSString *rightStr0 = [NSString stringWithFormat:@"%.02lf",model.actualPrice];
    NSString *showStr = [leftStr0 stringByAppendingString:rightStr0];
    NSMutableAttributedString *string = [[NSMutableAttributedString alloc] initWithString:showStr attributes: @{NSFontAttributeName: [UIFont systemFontOfSize:13.f]}];
    [string addAttributes:@{NSFontAttributeName: [UIFont boldSystemFontOfSize:32.f]} range:NSMakeRange(leftStr0.length, rightStr0.length)];
    [actPiceLabel setAttributedText:string];

    
    NSString *leftStr1 = @"￥";
    NSString *rightStr1 = [NSString stringWithFormat:@"%.02lf",model.originalPrice];
    NSMutableAttributedString *string1 = [[NSMutableAttributedString alloc] initWithString:[leftStr1 stringByAppendingString:rightStr1] attributes: @{NSFontAttributeName: [UIFont systemFontOfSize:13.f],NSStrikethroughStyleAttributeName: [NSNumber numberWithInteger:NSUnderlineStyleSingle]}];
    [orgPiceLabel setAttributedText:string1];
    
    /*有效期*/
    NSString *leftStr2 = [NSString stringWithFormat:@"%ld",model.effectiveTime];
    NSString *rightStr2 = NSLocalizedString(@"buy_vip_package_detail_day",nil);
    [vailTimeLabel setText:[leftStr2 stringByAppendingString:rightStr2]];
//    orgPiceLabel
//    vailTimeLabel
}

@end
