//
//  PlayResultViewController.m
//  隐私保护
//
//  Created by APPLE on 2023/8/29.
//

#import "PlayResultViewController.h"
#import "PayRecoderListViewController.h"
#import <Masonry.h>
#import "CloudPhoneAPI.h"
#import "UseAccountManage.h"
#import "WXApi.h"
#import "WXPayManager.h"
#import <AlipaySDK/AlipaySDK.h>

@interface PlayResultViewController ()<WXPayManagerDelegate>{
    UIImageView *topImageView;
    UILabel *topLabel;
    UILabel *detailLabel;
    UIButton *downBtn;
    NSInteger payStates;/*支付状态  0:支付中  1:支付成功  2:支付失败*/
}

@end

@implementation PlayResultViewController
@synthesize orderNum;
@synthesize selectPayType;

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(applicationDidBecomeActive:)  name:UIApplicationDidBecomeActiveNotification  object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(SafepayResult:)  name:NotificationNameBySafepayResult  object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(getPayDetailWithOrderNumWithPostN:)  name:NotNameAirpayOrWXorderNum  object:nil];
    
    [self drawAnyView];
    
    NSDictionary *parameters = [[NSDictionary alloc] initWithObjectsAndKeys:orderNum,@"orderNum", nil];
    [[UseAccountManage shareInstance] CommonGetWithCallBackCode:GetPayOrderAPI
                                                     Parameters:parameters
                                                        success:^(id  _Nonnull responseObject) {
        if (0 == CODE)
        {
            NSDictionary *dict = (NSDictionary *)responseObject;
            NSDictionary *payConnection;
            NSString *payConnectionStr = @"";
            if ([[dict allKeys] containsObject:@"data"])
            {
                NSDictionary *info = [dict objectForKey:@"data"];
                payConnection = [[NSDictionary alloc] initWithDictionary:info];
                if (info && [[info allKeys] containsObject:@"connection"])
                {
                    payConnectionStr = [info objectForKey:@"connection"];
                }
            }
            
            HLog(@"\n-----payConnection = %@---",payConnection);
            
            if (0 == self->selectPayType){/*微信*/
                /*调用微信接口*/
                [self payWXWithDict:payConnection];
            }else{/*支付宝*/
                [self payWithPayAuthstring:payConnectionStr];
            }
        }
    }
                                                        failure:^(NSError * _Nonnull error) {
        ;
    }];
    
}

- (void)drawAnyView{
    payStates = 0;
    [self.view setBackgroundColor:HWF5F7FAColor];
    [self.toolBar setHidden:YES];
    [self.navigationBar setHidden:YES];
    
    topImageView = [[UIImageView alloc] init];
    [self.view addSubview:topImageView];
    [topImageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(89.f + H_STATE_BAR);
        make.width.mas_equalTo(100.f);
        make.height.mas_equalTo(100.f);
        make.centerX.equalTo(self.view.mas_centerX);
    }];
    
    topLabel = [[UILabel alloc] init];
    [self.view addSubview:topLabel];
    [topLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(topImageView.mas_bottom).offset(5);
        make.right.mas_equalTo(-20.f);
        make.left.mas_equalTo(20.f);
    }];
    [topLabel setTextAlignment:(NSTextAlignmentCenter)];
    [topLabel setFont:[UIFont systemFontOfSize:16]];
    [topLabel setTextColor:HW0A132BColor];
    [topLabel setText:NSLocalizedString(@"buy_vip_pay_result_paying",nil)];
    
    detailLabel = [[UILabel alloc] init];
    [self.view addSubview:detailLabel];
    [detailLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(topLabel.mas_bottom).offset(10);
        make.right.mas_equalTo(-20.f);
        make.left.mas_equalTo(20.f);
    }];
    [detailLabel setTextAlignment:(NSTextAlignmentCenter)];
    [detailLabel setFont:[UIFont systemFontOfSize:13]];
    [detailLabel setTextColor:HW666666Color];
    [detailLabel setHidden:YES];
//    detailLabel
    
    /*底部按钮*/
    downBtn = [[UIButton alloc] init];
    downBtn.frame = CGRectMake(0, 0, 260.f, 48.f);

    // gradient
    CAGradientLayer *gl = [CAGradientLayer layer];
    gl.frame = CGRectMake(0,0,260.f,48.f);
    gl.startPoint = CGPointMake(0, 0.5);
    gl.endPoint = CGPointMake(1, 0.5);
    gl.colors = @[(__bridge id)HW0CDEFDColor.CGColor, (__bridge id)HW058DFBColor.CGColor];
    gl.locations = @[@(0), @(1.0f)];
    
    [downBtn.layer addSublayer:gl];
    [downBtn addTarget:self action:@selector(downBtnBtnClick) forControlEvents:(UIControlEventTouchUpInside)];
    [downBtn setTitle:NSLocalizedString(@"buy_vip_pay_result_back_vip",nil) forState:(UIControlStateNormal)];
    [downBtn setTitleColor:[UIColor whiteColor] forState:(UIControlStateNormal)];
    [downBtn.titleLabel setFont:[UIFont systemFontOfSize:16.f]];
    [downBtn.layer setCornerRadius:8.f];
    downBtn.clipsToBounds = YES;
    [self.view addSubview:downBtn];
    [downBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.view.mas_centerX);
        make.width.mas_equalTo(260.f);
        make.top.equalTo(detailLabel.mas_bottom).offset(30.f);
        make.height.mas_equalTo(48.f);
    }];
    
    [self updateView];
}

- (void)updateView{
    if (payStates == 0){
        [topImageView setImage:[UIImage imageNamed:@"buy_paying"]];
        [topLabel setText:NSLocalizedString(@"buy_vip_pay_result_paying",nil)];
        [detailLabel setHidden:YES];
        [downBtn setTitle:NSLocalizedString(@"buy_vip_pay_result_back_vip",nil) forState:(UIControlStateNormal)];
    }else if (payStates == 1){
        [topImageView setImage:[UIImage imageNamed:@"buy_pay_success"]];
        [topLabel setText:NSLocalizedString(@"buy_vip_pay_result_pay_success",nil)];
        [detailLabel setHidden:NO];
        [detailLabel setText:NSLocalizedString(@"buy_vip_pay_result_detail_success",nil)];
        [downBtn setTitle:NSLocalizedString(@"buy_vip_pay_result_ge_recoder",nil) forState:(UIControlStateNormal)];
    }else if (payStates == 2){
        [topImageView setImage:[UIImage imageNamed:@"buy_pay_faile"]];
        [topLabel setText:NSLocalizedString(@"buy_vip_pay_result_pay_faile",nil)];
        [detailLabel setHidden:NO];
        [detailLabel setText:NSLocalizedString(@"buy_vip_pay_result_detail_faile",nil)];
        [downBtn setTitle:NSLocalizedString(@"buy_vip_pay_result_back_vip",nil) forState:(UIControlStateNormal)];
    }
}

- (void)downBtnBtnClick{
    if (payStates == 1){
        /*跳入订单界面*/
        PayRecoderListViewController *nextVC = [[PayRecoderListViewController alloc] init];
        
        [self.navigationController pushViewController:nextVC animated:YES];
    }else{
        /*返回上一级界面*/
        [self.navigationController popViewControllerAnimated:YES];
    }
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (void)payWXWithDict:(NSDictionary*)payInfo
{
    /*提取appid*/
    if ([[payInfo allKeys] containsObject:@"appid"])
    {
//        NSString * universalLink = @"https://shuangzixing.com/";
//        if ([CloudService rangeOfString:@"pre"].location != NSNotFound) {
//            universalLink = @"https://shuangzixing.com/test";
//        }
        
        BOOL isOk0 = [WXApi registerApp:[payInfo objectForKey:@"appid"] universalLink:wxuniversalLink];
        
        if (isOk0)
        {
            HLog(@"\n注册ok");
        }
        else
        {
            HLog(@"\n注册失败");
        }
    }
    
    //    appid = wx017ed8921f249e1a;
    //    noncestr = 6bzhl5vMYgrFjQ9l;
    //    package = "Sign=WXPay";
    //    partnerid = 1544966281;
    //    prepayid = wx25164144265218461862fd281495268600;
    //    sign = E3CDA5E32067BF05F73ACBE12A1D1EB7;
    //    timestamp = 1569400904;
    
    HLog(@"\npayInfo = %@",payInfo);
    
    PayReq *request = [[PayReq alloc] init];
    if ([[payInfo allKeys] containsObject:@"partnerid"])
    {
        request.partnerId = [payInfo objectForKey:@"partnerid"];
    }
    
    if ([[payInfo allKeys] containsObject:@"prepayid"])
    {
        request.prepayId = [payInfo objectForKey:@"prepayid"];
    }
    
    if ([[payInfo allKeys] containsObject:@"package"])
    {
        request.package = [payInfo objectForKey:@"package"];
    }
    
    if ([[payInfo allKeys] containsObject:@"noncestr"])
    {
        request.nonceStr = [payInfo objectForKey:@"noncestr"];
    }
    
    if ([[payInfo allKeys] containsObject:@"timestamp"])
    {
        request.timeStamp = (int)[[payInfo objectForKey:@"timestamp"] integerValue];
    }
    
    if ([[payInfo allKeys] containsObject:@"sign"])
    {
        request.sign = [payInfo objectForKey:@"sign"];
    }
    
    //    BOOL isOk = [WXApi sendReq:request];
    [WXApi sendReq:request completion:^(BOOL success) {
        if (success)
     {

         [HWDataManager setStringWithKey:Const_AirpayOrWXorderNum value:self->orderNum];

     }
     else
     {
         KyoLog(@"\n调用失败");
     }

    }];


    [WXPayManager shareInstance].delegate = self;
}

- (void)onResp:(BaseResp *)resp payManager:(WXPayManager *)payManager
{
//    [self removeGetingView];
    switch (resp.errCode) {
        case WXSuccess:
        {
            HLog(@"支付成功－PaySuccess，retcode = %d", resp.errCode);
            /*跳入到成功界面*/
            /*跳入到成功界面*/
            payStates = 1;
            [self updateView];
        }
            break;

        default:
        {
            HLog(@"错误，retcode = %d, retstr = %@", resp.errCode,resp.errStr);
            /*跳入到失败界面*/
            payStates = 2;
            [self updateView];
        }
            break;
    }
}


- (void)getPayDetailWithOrderNumWithPostN:(NSNotification *)not
{
    NSString *resultNumber = [not object];
    
    
    if (!orderNum)
    {
        [self removeNewIndicatorHaveStr];
        /*跳入到成功界面*/
        payStates = 1;
        [self updateView];
        
        return;
    }
    
    payStates = 1;
    [self updateView];
}

- (void)SafepayResult:(NSNotification *)notification
{
    [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;
    
    NSDictionary *resultDict = [notification object];
    
    if ([[resultDict allKeys] containsObject:@"resultStatus"])
    {
        NSInteger resultStatus = [[resultDict objectForKey:@"resultStatus"] integerValue];
        
        NSString *memo = [resultDict objectForKey:@"memo"];
        
        
        switch (resultStatus)
        {
            case 9000:/*订单支付成功*/
                {
                    payStates = 1;
                    [self updateView];
                }
                break;
                case 8000:/*正在处理中，支付结果未知（有可能已经支付成功），请查询商户订单列表中订单的支付状态*/
                {
                    payStates = 2;
                    [self updateView];
                }
                break;
                case 4000:/*订单支付失败*/
                {
                    payStates = 2;
                    [self updateView];
                }
                break;
                case 5000:/*重复请求*/
                {
                    payStates = 2;
                    [self updateView];
                }
                break;
                case 6001:/*用户中途取消*/
                {
                    payStates = 2;
                    [self updateView];
                }
                break;
                case 6002:/*网络连接出错*/
                {
                    payStates = 2;
                    [self updateView];
                }
                break;
                
            default:/*未知错误*/
            {
                payStates = 2;
                [self updateView];
            }
                break;
        }
    }
}

- (void)payWithPayAuthstring:(NSString *)payAuthstring
{
    [HWDataManager setStringWithKey:Const_AirpayOrWXorderNum value:orderNum];
    
    [[AlipaySDK defaultService] payOrder:payAuthstring fromScheme:AirPaySecret callback:^(NSDictionary *resultDic) {
        HLog(@"reslut = %@",resultDic);
        [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;
        if ([[resultDic allKeys] containsObject:@"resultStatus"])
        {
            NSInteger resultStatus = [[resultDic objectForKey:@"resultStatus"] integerValue];
            
            NSString *memo = [resultDic objectForKey:@"memo"];
            
            switch (resultStatus)
            {
                case 9000:/*订单支付成功*/
                    {
                        self->payStates = 1;
                        [self updateView];
                    }
                    break;
                    case 8000:/*正在处理中，支付结果未知（有可能已经支付成功），请查询商户订单列表中订单的支付状态*/
                    {
                        self->payStates = 2;
                        [self updateView];
                    }
                    break;
                    case 4000:/*订单支付失败*/
                    {
                        self->payStates = 2;
                        [self updateView];
                    }
                    break;
                    case 5000:/*重复请求*/
                    {
                        self->payStates = 2;
                        [self updateView];
                    }
                    break;
                    case 6001:/*用户中途取消*/
                    {
                        self->payStates = 2;
                        [self updateView];
                    }
                    break;
                    case 6002:/*网络连接出错*/
                    {
                        self->payStates = 2;
                        [self updateView];
                    }
                    break;
                    
                default:/*未知错误*/
                {
                    self->payStates = 2;
                    [self updateView];
                }
                    break;
            }
        }
    }];
}
@end
