//
//  WXPayManager.m
//  VclustersGemini
//
//  Created by APPLE on 2019/9/25.
//  Copyright © 2019 APPLE. All rights reserved.
//

#import "WXPayManager.h"
#import "UseAccountManage.h"

static WXPayManager *shareInstance = nil;


@interface WXPayManager ()<WXApiDelegate>
{
    ;
}
@end


@implementation WXPayManager
@synthesize delegate;

+(WXPayManager *)shareInstance
{
    static dispatch_once_t onceToken;
    
    dispatch_once(&onceToken, ^{
        shareInstance = [[WXPayManager alloc]init];
        
    });
    
    return shareInstance;
}


-(void)onReq:(BaseReq*)req
{
    ;
}


-(void)onResp:(BaseResp*)resp
{
//    WXSuccess           = 0,    /**< 成功    */
//    WXErrCodeCommon     = -1,   /**< 普通错误类型    */
//    WXErrCodeUserCancel = -2,   /**< 用户点击取消并返回    */
//    WXErrCodeSentFail   = -3,   /**< 发送失败    */
//    WXErrCodeAuthDeny   = -4,   /**< 授权失败    */
//    WXErrCodeUnsupport  = -5,   /**< 微信不支持    */
    
    if([resp isKindOfClass:[PayResp class]]){ // 微信支付
        //支付返回结果，实际支付结果需要去微信服务器端查询
        NSString *strMsg = [NSString stringWithFormat:@"支付结果"];
        
        if ([delegate respondsToSelector:@selector(onResp:payManager:)])
        {
            [delegate onResp:resp payManager:self];
        }
    }
}

#pragma mark 微信登录
// 1、sendAuthReq向微信发送请求
- (void)authorizeWXLoginWithVC:(UIViewController *)vc {
    
    SendAuthReq *req = [[SendAuthReq alloc] init];
    req.scope = @"snsapi_userinfo";
    req.state = @"App";
    [WXApi sendAuthReq:req viewController:vc delegate:[WXPayManager shareInstance] completion:^(BOOL success) {
        ;
    }];
}


#pragma mark 懒加载
- (NSMutableDictionary *)loginParams {
    if (!_loginParams) {
        _loginParams = [NSMutableDictionary dictionary];
    }
    return _loginParams;;
}

@end
