//
//  ViewForPhoneAndSMS.m
//  VclustersGemini
//
//  Created by APPLE on 2020/4/8.
//  Copyright © 2020 APPLE. All rights reserved.
//

#import "ViewForPhoneAndSMS.h"
#import "IQKeyboardManager.h"
#import "SetUserAgreementView.h"
#import "UITextfield+NLLimit.h"
#import "SuperModel.h"
#import "iPhone.h"
#import "UseAccountManage.h"
#import "CloudPhoneAPI.h"

@interface ViewForPhoneAndSMS ()<InputViewForSMSCodDelegate,UITextFieldDelegate,SetUserAgreementViewDelegate>
{
    SetUserAgreementView *mSetUserAgreementView;
    
    UIActivityIndicatorView*wattingVideoImageindicator;
    UIView *wattingView;
    BOOL   needSowWattingView;
    UIButton *okBtn;
}

@end

@implementation ViewForPhoneAndSMS
@synthesize delegate;
@synthesize mInputView;

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    
    if (self)
    {
        [self drawAnyView];
    }
    
    return self;
}

- (void)drawAnyView
{
    /*标题*/
    UILabel *titleLabel = [[UILabel alloc] init];
    [titleLabel setBackgroundColor:[UIColor clearColor]];
    [titleLabel setTextColor:HW333333Color];
    [titleLabel setFont:[UIFont boldSystemFontOfSize:18.f]];
    [titleLabel setText:NSLocalizedString(@"log_phone_sms_login",nil)];
    [titleLabel setTextAlignment:(NSTextAlignmentCenter)];
    [self addSubview:titleLabel];
    
    [titleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(37.f);
        make.top.mas_equalTo(145.f + H_STATE_BAR);
    }];
    
    UILabel *downTitleLabel = [[UILabel alloc] init];
    [downTitleLabel setBackgroundColor:[UIColor clearColor]];
    [downTitleLabel setTextColor:HW666666Color];
    [downTitleLabel setFont:[UIFont boldSystemFontOfSize:14.f]];
    [downTitleLabel setText:NSLocalizedString(@"log_phone_sms_login_creat_account",nil)];
    [downTitleLabel setTextAlignment:(NSTextAlignmentCenter)];
    [self addSubview:downTitleLabel];
    
    [downTitleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(37.f);
        make.top.equalTo(titleLabel.mas_bottom).offset(6.f);
    }];
    
    /*输入框视图*/
    mInputView = [[InputViewForSMSCod alloc] initWithFrame:CGRectZero];
    [self addSubview:mInputView];
    
    mInputView.delegate = self;
    mInputView.phoneNumInput.delegate = self;
    mInputView.smsInput.delegate = self;
    [mInputView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(downTitleLabel.mas_bottom).offset(44.f);
        make.left.and.right.mas_equalTo(0.f);
        make.height.mas_equalTo(68.f*2);
    }];
    [mInputView.phoneNumInput setNl_maxLength:11];
    //    [self smsCutDownCheck];
    [mInputView.smsCodeBtn setEnabled:NO];
    
    
    /*确认按钮*/
    okBtn = [[UIButton alloc] init];
    CGFloat okBtn_W = SCREEN_W - 2*37.f*AUTOSCALE;
    
    // gradient
    CAGradientLayer *gl = [CAGradientLayer layer];
    gl.frame = CGRectMake(0,0,okBtn_W,48);
    gl.startPoint = CGPointMake(0, 0.5);
    gl.endPoint = CGPointMake(1, 0.5);
    gl.colors = @[(__bridge id)HW0CDEFDColor.CGColor, (__bridge id)HW058DFBColor.CGColor];
    gl.locations = @[@(0), @(1.0f)];
    okBtn.layer.cornerRadius = 8;
    okBtn.clipsToBounds = YES;
    [okBtn.layer addSublayer:gl];
    [okBtn setTitle:NSLocalizedString(@"other_confirm",nil) forState:(UIControlStateNormal)];
    [okBtn setTitleColor:[UIColor whiteColor] forState:(UIControlStateNormal)];
    [okBtn.titleLabel setFont:[UIFont systemFontOfSize:16.f]];
    [self addSubview:okBtn];
    [okBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(mInputView.mas_bottom).offset(40.f);
        make.centerX.equalTo(self.mas_centerX);
        make.width.mas_equalTo(okBtn_W);
        make.height.mas_equalTo(48);
    }];
    
    [okBtn addTarget:self
               action:@selector(okBtnPressed)
     forControlEvents:(UIControlEventTouchUpInside)];
    [okBtn setEnabled:NO];
    [okBtn setAlpha:0.5];
    
    /*用户协议视图*/
    mSetUserAgreementView = [[SetUserAgreementView alloc] initWithFrame:CGRectZero];
    mSetUserAgreementView.delegate = self;
    [self addSubview:mSetUserAgreementView];
    [mSetUserAgreementView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(mInputView.mas_bottom).offset(91.f);
        make.right.and.left.mas_equalTo(0.f);
        make.height.mas_equalTo(40.f);
    }];
}

#pragma mark - SetUserAgreementViewDelegate
//用户使用协议
- (void)optionalBtnPressed
{
    HLog(@"\n----协议按钮被点击-------");
    
    if ([delegate respondsToSelector:@selector(smsOptionalBtnPressed)])
    {
        [delegate smsOptionalBtnPressed];
    }
}

//隐私协议
- (void)privateBtnPressed
{
    HLog(@"\n----隐私协议按钮被点击-------");
    
    if ([delegate respondsToSelector:@selector(smsPrivateBtnPressed)])
    {
        [delegate smsPrivateBtnPressed];
    }
}

- (void)smsCutDownCheck
{
    /*保存定时器开始时间*/
    double nowsmsCodeGetTime = [[NSDate date] timeIntervalSince1970];

    NSNumber *smsCodeGetTime = [HWDataManager getNumberWithKey:Const_lastsmsCodeGetTimeForLoginSMS];
    if (smsCodeGetTime)
    {
        double lastsmsCodeGetTimeForLoginSMS = [smsCodeGetTime doubleValue];
        double bTmie = nowsmsCodeGetTime - lastsmsCodeGetTimeForLoginSMS;
        if (bTmie < 60)
        {
            if (bTmie < 0)
            {
                bTmie = 0;
            }
            
            /*设置倒计时*/
            NSString *smsCodeBtnstr = [NSString stringWithFormat:@"%02lds后重试",(long)(60 - bTmie)];
            [mInputView.smsCodeBtn setTitle:smsCodeBtnstr forState:(UIControlStateNormal)];
            [mInputView.smsCodeBtn.titleLabel setFont:[UIFont systemFontOfSize:14.f]];
            [mInputView.smsCodeBtn setEnabled:NO];
            
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.f * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [self setSMSCodeBtnStates];
            });
        }
        else
        {
            [mInputView.smsCodeBtn setTitle:@"获取验证码" forState:(UIControlStateNormal)];
            [mInputView.smsCodeBtn.titleLabel setFont:[UIFont systemFontOfSize:13.f]];
            [mInputView.smsCodeBtn setEnabled:YES];
        }
    }
}

- (void)smsCutDownCheckInBack
{
    /*保存定时器开始时间*/
    double nowsmsCodeGetTime = [[NSDate date] timeIntervalSince1970];

    NSNumber *smsCodeGetTime = [HWDataManager getNumberWithKey:Const_lastsmsCodeGetTimeForLoginSMS];
    if (smsCodeGetTime)
    {
        double lastsmsCodeGetTimeForLoginSMS = [smsCodeGetTime doubleValue];
        double bTmie = nowsmsCodeGetTime - lastsmsCodeGetTimeForLoginSMS;
        if (bTmie < 60)
        {
            if (bTmie < 0)
            {
                bTmie = 0;
            }
            
            /*设置倒计时*/
            NSString *smsCodeBtnstr = [NSString stringWithFormat:@"%02lds后重试",(long)(60 - bTmie)];
            [mInputView.smsCodeBtn setTitle:smsCodeBtnstr forState:(UIControlStateNormal)];
            [mInputView.smsCodeBtn.titleLabel setFont:[UIFont systemFontOfSize:14.f]];
            [mInputView.smsCodeBtn setEnabled:NO];
        }
        else
        {
            [mInputView.smsCodeBtn setTitle:@"获取验证码" forState:(UIControlStateNormal)];
            [mInputView.smsCodeBtn.titleLabel setFont:[UIFont systemFontOfSize:13.f]];
            [mInputView.smsCodeBtn setEnabled:YES];
        }
    }
}

/**
 * @brief 判断是否正在倒计时
 *
 */
- (BOOL)smsCutDownInDoing
{
    /*保存定时器开始时间*/
    double nowsmsCodeGetTime = [[NSDate date] timeIntervalSince1970];

    NSNumber *smsCodeGetTime = [HWDataManager getNumberWithKey:Const_lastsmsCodeGetTimeForLoginSMS];
    if (smsCodeGetTime)
    {
        double lastsmsCodeGetTimeForReg = [smsCodeGetTime doubleValue];
        double bTmie = nowsmsCodeGetTime - lastsmsCodeGetTimeForReg;
        
        HLog(@"\n-----开始时间-》%ld---  现在时间---》%ld",lastsmsCodeGetTimeForReg,(long int)nowsmsCodeGetTime);
        
        if (bTmie < 60)
        {
            if (bTmie < 0)
            {
                bTmie = 0;
            }
            
            return YES;
        }
        else
        {
            return NO;
        }
    }
    
    return NO;
}

/**
 * @brief 开始倒计时
 *
 */
- (void)startCountdown
{
    [mInputView.smsCodeBtn setTitle:@"60S" forState:(UIControlStateNormal)];
    [mInputView.smsCodeBtn.titleLabel setFont:[UIFont systemFontOfSize:14.f]];
    [mInputView.smsCodeBtn setEnabled:NO];
    
    /*保存定时器开始时间*/
    double lastsmsCodeGetTimeForLoginSMS = [[NSDate date] timeIntervalSince1970];

    [HWDataManager setNumberWithKey:Const_lastsmsCodeGetTimeForLoginSMS value:[NSNumber numberWithDouble:lastsmsCodeGetTimeForLoginSMS]];
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.f * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self setSMSCodeBtnStates];
    });
}

- (void)setSMSCodeBtnStates
{
    NSString *smsBtnStr= mInputView.smsCodeBtn.titleLabel.text;
    
    /*倒计时中*/
    if ([smsBtnStr rangeOfString:@"S"].location != NSNotFound)
    {
        NSRange letfnumber  = [smsBtnStr rangeOfString:@"S"];
        NSRange strRange = NSMakeRange(0, letfnumber.location);
        /*获取当中的数字*/
        NSString *numberStr = [smsBtnStr substringWithRange:strRange];
        NSInteger numerSec = [numberStr integerValue];
        numerSec--;
        if (numerSec>= 0)
        {
            [mInputView.smsCodeBtn setTitle:[NSString stringWithFormat:@"%02ldS",(long)numerSec] forState:(UIControlStateNormal)];
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.f * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [self setSMSCodeBtnStates];
            });
        }
        else
        {
            [mInputView.smsCodeBtn setTitle:@"获取验证码" forState:(UIControlStateNormal)];
            [mInputView.smsCodeBtn.titleLabel setFont:[UIFont systemFontOfSize:13.f]];
            [mInputView.smsCodeBtn setEnabled:YES];
        }
    }
}

- (BOOL) checkEmptyString:(NSString *) string {
    
    if (string == nil) return string == nil;
    
    NSString *newStr = [string stringByReplacingOccurrencesOfString:@" " withString:@""];
    return [newStr isEqualToString:@""];
}

#pragma mark - LoginChangeViewDelegate
- (void)loginBtnBePressed:(id)sender
{
    /*验证信息有效性*/
    [(UIButton *)sender setEnabled:NO];
    [(UIButton *)sender setBackgroundColor:COLOR_DISABLE_BTN];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [(UIButton *)sender setEnabled:YES];
        [(UIButton *)sender setBackgroundColor:COLOR_ENABLE_BTN];
    });
    
    HLog(@"\n----注册按钮被点击-------");
    if ([mInputView.phoneNumInput.text isEqualToString:@""] || mInputView.phoneNumInput.text == nil)
    {
        [mInputView.phoneNumInput becomeFirstResponder];
        
        [[iToast makeText:@"电话号码不能为空"] show];
    }
    else if ([mInputView.smsInput.text isEqualToString:@""] || mInputView.smsInput.text == nil)
    {
        [mInputView.smsInput becomeFirstResponder];
        
        [[iToast makeText:@"验证码不能为空"] show];
    }
    
    /*判断电话号码格式*/
    BOOL isVaildPhoneNo = [iPhone isVaildPhoneNo:mInputView.phoneNumInput.text];
    if (!isVaildPhoneNo)
    {
        [mInputView.phoneNumInput becomeFirstResponder];
        
        [[iToast makeText:@"手机号输入有误"] show];
        
        return;
    }
    
    if ([delegate respondsToSelector:@selector(smsLoginWithPhonenumber:code:)])
    {
        [delegate smsLoginWithPhonenumber:mInputView.phoneNumInput.text code:mInputView.smsInput.text];
    }
}


#pragma mark - InputViewForSMSCodDelegate
- (void)smsCodeBtnBePressed:(id)sener smsCodeInputView:(UITextField *)inputView
{
    HLog(@"\n----获取验证码被点击-------");
    if ([mInputView.phoneNumInput.text isEqualToString:@""] || mInputView.phoneNumInput.text == nil)
    {
        //        [self tipsStrUpdateStr:@"电话号码不能为空" color:[UIColor redColor]];
        //        [tipsLabel setHidden:NO];
        [mInputView.phoneNumInput becomeFirstResponder];
        
        //        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        //            [self->tipsLabel setHidden:YES];
        //        });
        [[iToast makeText:@"电话号码不能为空"] show];
        [mInputView.phoneErrorTipsLabel setHidden:NO];
        return;
    }
    
    /*判断电话号码格式*/
    BOOL isVaildPhoneNo = [iPhone isVaildPhoneNo:mInputView.phoneNumInput.text];
    if (!isVaildPhoneNo)
    {
        //        [tipsLabel setHidden:NO];
        //        [self tipsStrUpdateStr:@"手机号输入有误" color:[UIColor redColor]];
        [mInputView.phoneNumInput becomeFirstResponder];
        
        //        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        //            [self->tipsLabel setHidden:YES];
        //        });
        [[iToast makeText:@"手机号输入有误"] show];
        [mInputView.phoneErrorTipsLabel setHidden:NO];
        return;
    }
    
    HLog(@"\n---获取验证码----");
    if ([delegate respondsToSelector:@selector(smsGetLoginSmsCodeWithPhonenumber:)])
    {
        [delegate smsGetLoginSmsCodeWithPhonenumber:mInputView.phoneNumInput.text];
    }
    
    /*获取验证码   post请求
     输入参数         phone     NSString    电话号码
     type      NSString   regist:注册
     login:验证码登录
     passwd_back:找回密码
     modify_phone:修改手机号码
     send_star_coin:赠送星币
     common:微信登录、QQ登录、Apple登录、第三方登录设置密码
     authorizationType     NSString   1:微信登录 2:QQ登录  3:Apple登录 其它情况无需该字段
     
     返回数据模型 SuperModel*/
    [self showNewIndicator];
    [[UseAccountManage shareInstance] commonPostCanWithOutTokenCallBackCode:SMSVerCodeAPI
                                                                 Parameters:@{@"type":@"regist",@"phone":mInputView.phoneNumInput.text}
                                                                    success:^(id  _Nonnull responseObject) {
        SuperModel *mod = [[SuperModel alloc] initWithDictionary:responseObject error:nil];
        [self removeNewIndicator];
        NSString *showStr = nil;
        showStr = mod.msg;
        if (mod.status && mod.status.integerValue == 0)
        {
            if (mod.msg == nil || [mod.msg isEqualToString:@""])
            {
                showStr = @"操作成功";
            }
            
            [self startCountdown];
        }
        else
        {
            if (mod.msg == nil || [mod.msg isEqualToString:@""])
            {
                showStr = NSLocalizedString(@"log_login_system_busy",nil);
            }
        }
        
        [[iToast makeText:showStr] show];
    }
                                                                    failure:^(NSError * _Nonnull error) {
        [[iToast makeText:NSLocalizedString(@"log_login_system_busy",nil)] show];
        [self removeNewIndicator];
    }];
}

#pragma mark - UITextFieldDelegate
- (void)textFieldDidEndEditing:(UITextField *)textField
{
    if (textField == mInputView.phoneNumInput || textField == mInputView.smsInput)
    {
        if ([mInputView.phoneNumInput.text isEqualToString:@""]
            || mInputView.phoneNumInput.text == nil)
        {
            [mInputView.smsCodeBtn setEnabled:NO];
        }
        else
        {
            //            if ([self smsCutDownInDoing])
            if (![mInputView.smsCodeBtn.titleLabel.text isEqualToString:@"获取验证码"])
            {
                [mInputView.smsCodeBtn setEnabled:NO];
            }
            else
            {
                [mInputView.smsCodeBtn setEnabled:YES];
            }
        }
    }
}

- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string
{
    if (textField == mInputView.smsInput){
        [mInputView.smsErrorTipsLabel setHidden:YES];
    }else if (textField == mInputView.phoneNumInput){
        [mInputView.phoneErrorTipsLabel setHidden:YES];
    }
    if (textField == mInputView.phoneNumInput || textField == mInputView.smsInput)
    {
        if ([mInputView.phoneNumInput.text isEqualToString:@""]
            || mInputView.phoneNumInput.text == nil)
        {
            [mInputView.smsCodeBtn setEnabled:NO];
        }
        else
        {
            //            if ([self smsCutDownInDoing])
            if (![mInputView.smsCodeBtn.titleLabel.text isEqualToString:@"获取验证码"])
            {
                [mInputView.smsCodeBtn setEnabled:NO];
            }
            else
            {
                [mInputView.smsCodeBtn setEnabled:YES];
            }
        }
    }
    
    if (textField == mInputView.smsInput)
    {
        /*特定字符限制*/
        NSCharacterSet *cs;
        cs = [[NSCharacterSet characterSetWithCharactersInString:@"0123456789"]invertedSet];
        NSString *filtered = [[string componentsSeparatedByCharactersInSet:cs]componentsJoinedByString:@""];//按cs分离出数组,数组按@""分离出字符串
        
        BOOL canChange = [string isEqualToString:filtered];
        if ([mInputView.phoneNumInput.text isEqualToString:@""]
            || mInputView.phoneNumInput.text == nil
            || [mInputView.smsInput.text isEqualToString:@""]
            || mInputView.smsInput.text == nil)
        {
            [okBtn setEnabled:NO];
            [okBtn setAlpha:0.5];
        }else{
            [okBtn setEnabled:YES];
            [okBtn setAlpha:1];
        }
        return canChange;
    }
    else if (textField == mInputView.phoneNumInput)
    {
        /*特定字符限制*/
        NSCharacterSet *cs;
        cs = [[NSCharacterSet characterSetWithCharactersInString:@"0123456789"]invertedSet];
        NSString *filtered = [[string componentsSeparatedByCharactersInSet:cs]componentsJoinedByString:@""];//按cs分离出数组,数组按@""分离出字符串
        
        BOOL canChange = [string isEqualToString:filtered];
        
        if ([mInputView.phoneNumInput.text isEqualToString:@""]
            || mInputView.phoneNumInput.text == nil
            || [mInputView.smsInput.text isEqualToString:@""]
            || mInputView.smsInput.text == nil)
        {
            [okBtn setEnabled:NO];
            [okBtn setAlpha:0.5];
        }else{
            [okBtn setEnabled:YES];
            [okBtn setAlpha:1];
        }
        return canChange;
    }
    
    if ([mInputView.phoneNumInput.text isEqualToString:@""]
        || mInputView.phoneNumInput.text == nil
        || [mInputView.smsInput.text isEqualToString:@""]
        || mInputView.smsInput.text == nil)
    {
        [okBtn setEnabled:NO];
        [okBtn setAlpha:0.5];
    }else{
        [okBtn setEnabled:YES];
        [okBtn setAlpha:1];
    }
    return YES;
}

- (void)hiddenKeyboard
{
    [mInputView hiddenKeyboard];
}

-(BOOL)agreementButtonIsSelect
{
    return mSetUserAgreementView.agreeBtn.isSelected;
}

#pragma mark - UIApplication Delegate
- (void)applicationWillResignActive:(NSNotification *)notification
{
    /*记录定时器 开始时间*/
}

- (void)applicationDidBecomeActive:(NSNotification *)notification
{
    /*获取上一次定时器开始时间*/
    mainBlock(^{
        [self smsCutDownCheckInBack];
    });
}

#pragma mark- 加载框
-(void)showNewIndicator
{
    needSowWattingView = YES;
    
    [self setUserInteractionEnabled:NO];
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.0 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        if (self->needSowWattingView)
        {
            if (self->wattingView == nil)
            {
                HLog(@"Tan +++++开");
                self->wattingView =  [[UIView alloc] initWithFrame:CGRectMake(0, 0, 100, 100)];
                [self->wattingView setBackgroundColor:RGBACOLOR(0.f, 0.f, 0.f, 0.7)];
                [self->wattingView.layer setCornerRadius:10.f];
                self->wattingView.center = [[UIApplication sharedApplication] keyWindow].center;// 将wattingVideoImageindicator放于播放画面的中央位置
                self->wattingView.hidden = NO;
                
                UIImageView *anmImageView = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 100, 100)];
                [anmImageView setTag:1111];
                [anmImageView setImage:[UIImage imageNamed:@"WechatIMG1"]];
                [self->wattingView addSubview:anmImageView];
                
                CABasicAnimation* rotationAnimation = [CABasicAnimation animationWithKeyPath:@"transform.rotation.z"];
                rotationAnimation.toValue = [NSNumber numberWithFloat: M_PI * 2.0 ];
                rotationAnimation.duration = 2;
                rotationAnimation.cumulative = YES;
                rotationAnimation.repeatCount = HUGE_VALF;
                [anmImageView.layer addAnimation:rotationAnimation forKey:@"rotationAnimation"];
                
                //
                [[[UIApplication sharedApplication] keyWindow] addSubview:self->wattingView];
                //        [self performSelector:@selector(showRefreshHandle) withObject:nil afterDelay:60];
            }
        }
    });
}


-(void)removeNewIndicator
{
    needSowWattingView = NO;
    __weak __typeof(self) weakSelf = self;
    dispatch_async(dispatch_get_main_queue(), ^{
        [weakSelf setUserInteractionEnabled:YES];
        if (self->wattingView != nil)
        {
            [[self->wattingView viewWithTag:1111].layer removeAllAnimations];
            
            self->wattingView.hidden = YES;
            [self->wattingView removeFromSuperview];
            self->wattingView = nil;
        }
    });
}

- (void)refreshUI
{
    [mSetUserAgreementView refreshUI];
}

- (void)okBtnPressed{
    /*验证信息有效性*/
    [okBtn setEnabled:NO];
    [okBtn setAlpha:0.5];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self->okBtn setEnabled:YES];
        [self->okBtn setAlpha:1.0];
    });
    
    HLog(@"\n----注册按钮被点击-------");
    if ([mInputView.phoneNumInput.text isEqualToString:@""] || mInputView.phoneNumInput.text == nil)
    {
        [mInputView.phoneNumInput becomeFirstResponder];
        
        [[iToast makeText:@"电话号码不能为空"] show];
        [mInputView.phoneErrorTipsLabel setHidden:NO];
    }
    else if ([mInputView.smsInput.text isEqualToString:@""] || mInputView.smsInput.text == nil)
    {
        [mInputView.smsInput becomeFirstResponder];
        
        [[iToast makeText:@"验证码不能为空"] show];
        [mInputView.smsErrorTipsLabel setHidden:NO];
    }
    
    /*判断电话号码格式*/
    BOOL isVaildPhoneNo = [iPhone isVaildPhoneNo:mInputView.phoneNumInput.text];
    if (!isVaildPhoneNo)
    {
        [mInputView.phoneNumInput becomeFirstResponder];
        
        [[iToast makeText:@"手机号输入有误"] show];
        [mInputView.phoneErrorTipsLabel setHidden:NO];
        return;
    }
    
    if ([delegate respondsToSelector:@selector(smsLoginWithPhonenumber:code:)])
    {
        [delegate smsLoginWithPhonenumber:mInputView.phoneNumInput.text code:mInputView.smsInput.text];
    }
}

@end
