//
//  MySetViewController.m
//  双子星云手机
//
//  Created by APPLE on 2023/8/17.
//

#import "MySetViewController.h"
#import <SDWebImage.h>
#import <Masonry.h>
#import "UseAccountManage.h"
#import "HelpDownScrollView.h"
#import "MineViewCell.h"
#import "ChangeLogoViewController.h"
#import "HidenMaskSetViewController.h"
#import "CustomerWebViewController.h"
#import "AboutViewController.h"
#import "iPhone.h"

@interface MySetViewController ()<HelpDownScrollViewDelegate,UITableViewDelegate,UITableViewDataSource>

@property (nonatomic, strong, nullable) UITableView *tableView;

@end

@implementation MySetViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    [self drawAnyView];
}

- (void)drawAnyView{
    [self.view setBackgroundColor:HWF5F7FAColor];
    
    [self.toolBar setHidden:YES];
    [self.navigationBar setHidden:YES];
    
    [self.view addSubview:self.tableView];
    [self.tableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
        make.top.mas_equalTo(0);
    }];
    
    [self.tableView setTableHeaderView:[self headViewForTable]];
}

- (UIView *)headViewForTable{
    /*236顶部视图，  44中间试图下部分，  126下方视图*/
    UIView *headView = [[UIView alloc] initWithFrame:(CGRectMake(0, 0, SCREEN_W, 236.f + 44.f + 126))];
    [headView setBackgroundColor:[UIColor clearColor]];
    
    UIImage *bgImage = [UIImage imageNamed:@"set_up_bg"];
//    bgImage = [bgImage resizableImageWithCapInsets:UIEdgeInsetsMake(0, 0, 40, 80)];
    
    UIImageView *bgImView = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, SCREEN_W, 236.f)];
    [bgImView setImage:bgImage];
    [headView addSubview:bgImView];
    
    /*头像*/
    UIImageView *photoImage = [[UIImageView alloc] init];
    [photoImage setImage:[UIImage imageNamed:@"photo_normal"]];
    [bgImView addSubview:photoImage];
    [photoImage mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(16.f);
        make.top.mas_equalTo(99.f);
        make.width.mas_equalTo(62.f);
        make.height.mas_equalTo(62.f);
    }];
    
    NSDictionary *loginInfo = [[UseAccountManage shareInstance] getLoginInfo];
    /*用户名*/
    UILabel *phoneLabel = [[UILabel alloc] init];
    [phoneLabel setFont:[UIFont boldSystemFontOfSize:18.f]];
    [phoneLabel setTextColor:[UIColor whiteColor]];
    
    if (loginInfo && [[loginInfo allKeys] containsObject:@"phone"]){
        [phoneLabel setText:[loginInfo objectForKey:@"phone"]];
    }
    [bgImView addSubview:phoneLabel];
    [phoneLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(photoImage.mas_right).offset(9);
        make.centerY.equalTo(photoImage.mas_centerY);
        make.right.mas_equalTo(-22.f);
        make.height.mas_equalTo(25.f);
    }];
    
    /*下方会员视图*/
//    vip_bg
    UIImageView *downBgView = [[UIImageView alloc] init];
    [downBgView setImage:[UIImage imageNamed:@"vip_bg"]];
    [headView addSubview:downBgView];
    [downBgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(15.f);
        make.right.mas_equalTo(-15.f);
        make.bottom.mas_equalTo(-126.f);
        make.height.mas_equalTo(96.f);
    }];
    [downBgView setUserInteractionEnabled:YES];
    
    /*VIP类型*/
    UILabel *vipType = [[UILabel alloc] init];
    [vipType setText:@"VIP"];
    [vipType setTextColor:[UIColor whiteColor]];
    [vipType setFont:[UIFont boldSystemFontOfSize:24.f]];
    [downBgView addSubview:vipType];
    [vipType mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(20.f);
        make.right.mas_equalTo(-100.f);
        make.top.mas_equalTo(18.f);
        make.height.mas_equalTo(33.f);
    }];
    
    /*VIP类型提示*/
    UILabel *vipTypeTipsLabel = [[UILabel alloc] init];
    [vipTypeTipsLabel setText:@"你当前为非会员,无法享受专属私密手机"];
    [vipTypeTipsLabel setTextColor:[UIColor whiteColor]];
    [vipTypeTipsLabel setFont:[UIFont systemFontOfSize:12.f]];
    [downBgView addSubview:vipTypeTipsLabel];
    [vipTypeTipsLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(20.f);
        make.right.mas_equalTo(-100.f);
        make.top.mas_equalTo(53.f);
        make.height.mas_equalTo(17.f);
    }];
    
    /*免费会员按钮*/
    UIButton *vipBtn = [[UIButton alloc] init];
    [vipBtn setBackgroundColor:[UIColor whiteColor]];
    [vipBtn setTitle:@"免费领会员" forState:(UIControlStateNormal)];
    [vipBtn setTitleColor:HW0A132BColor forState:(UIControlStateNormal)];
    [vipBtn.titleLabel setFont:[UIFont systemFontOfSize:13.f]];
    [vipBtn addTarget:self
               action:@selector(vipBtnPressed)
     forControlEvents:(UIControlEventTouchUpInside)];
    [vipBtn.layer setCornerRadius:31.f/2.f];
    [downBgView addSubview:vipBtn];
    [vipBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(86.f);
        make.right.mas_equalTo(-20.f);
        make.centerY.equalTo(downBgView.mas_centerY);
        make.height.mas_equalTo(31.f);
    }];
    
    /*下方视图*/
    HelpDownScrollView *helpDownScrollView = [[HelpDownScrollView alloc] initWithFrame:CGRectMake(0, 0, SCREEN_W - 30, 96.f) withImageAry:@[@"icon-tubiao",@"icon-jincheng"] tilteAry:@[@"更换图标",@"进程隐藏"] numberOfLine:3];
    helpDownScrollView.presedDelegate = self;
    [headView addSubview:helpDownScrollView];
    [helpDownScrollView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(15.f);
        make.right.mas_equalTo(-15.f);
        make.bottom.mas_equalTo(-15.f);
        make.height.mas_equalTo(96.f);
    }];
    [helpDownScrollView setBackgroundColor:[UIColor whiteColor]];
    [helpDownScrollView.layer setCornerRadius:8.f];
    
    return headView;
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (void)helpDownScrollViewBePressed:(nonnull id)sender withIndex:(NSInteger)index {
    HLog(@"\n----点击了第个%ld按钮----",index);
    if (index == 0){
        ChangeLogoViewController *nextVC = [[ChangeLogoViewController alloc] init];
        [self.navigationController pushViewController:nextVC animated:YES];
    }else if (index == 1){/**/
        HidenMaskSetViewController *nextVC = [[HidenMaskSetViewController alloc] init];
        [self.navigationController pushViewController:nextVC animated:YES];
    }
}

#pragma mark - 懒加载
- (UITableView *)tableView{
    if (!_tableView) {
        _tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, SCREEN_W, SCREEN_H - TABBARHEIGHT) style:UITableViewStyleGrouped];
        _tableView.delegate = self;
        _tableView.dataSource = self;
        _tableView.showsVerticalScrollIndicator = NO;
        _tableView.showsHorizontalScrollIndicator = NO;
        _tableView.contentInset = UIEdgeInsetsMake(-H_STATE_BAR, 0, 0, 0);
        [_tableView setSeparatorStyle:(UITableViewCellSeparatorStyleNone)];
        [_tableView setSeparatorColor:[UIColor clearColor]];
        [_tableView setBackgroundColor:[UIColor clearColor]];
        [_tableView setTableFooterView:[UIView new]];
        [_tableView setBounces:YES];
        if (@available(iOS 15.0, *)) {
            _tableView.sectionHeaderTopPadding = 0;
        }

    }
    
    return _tableView;
}

#pragma mark - 列表委托
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    return 4;
}


- (MineViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    NSInteger row = indexPath.row;
    static NSString *identifier = @"MineViewCell";
    
    MineViewCell * cell =  [tableView dequeueReusableCellWithIdentifier:identifier];
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    if (!cell){
        cell = [[MineViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:identifier];
        [cell setSelectionStyle:UITableViewCellSelectionStyleNone];
        [cell setBackgroundColor:[UIColor clearColor]];
        [cell setAccessoryType:(UITableViewCellAccessoryNone)];
    }
    [cell.bgViewLayer removeFromSuperlayer];
    [cell.titleLabel2 setHidden:YES];
    [cell.rightImage setHidden:NO];
    [cell.lineView setHidden:NO];
    if (row == 0){
        [cell.titleLabel setText:@"邀请好友"];
        [cell.titleLabel2 setText:@"邀请好友送会员"];
        [cell.mImageView setImage:[UIImage imageNamed:@"icon-yaoqing"]];
        [cell.titleLabel2 setHidden:NO];
        /*上圆角*/
        //设置部分圆角  贝塞尔曲线
        UIBezierPath *maskPath = [UIBezierPath bezierPathWithRoundedRect:CGRectMake(0, 0, SCREEN_W-30 , 60)
                                                       byRoundingCorners:UIRectCornerTopLeft | UIRectCornerTopRight
                                                             cornerRadii:CGSizeMake(8, 8)];
        CAShapeLayer *maskLayer = [[CAShapeLayer alloc] init];
        maskLayer.frame = cell.cellBgView.bounds;
        maskLayer.path = maskPath.CGPath;
        cell.bgViewLayer = maskLayer;
        cell.cellBgView.layer.mask = cell.bgViewLayer;
        
    }else if (row == 1){
        [cell.titleLabel setText:@"检测更新"];
        [cell.mImageView setImage:[UIImage imageNamed:@"icon-gengxin"]];
    }else if (row == 2){
        [cell.titleLabel setText:@"联系客服"];
        [cell.mImageView setImage:[UIImage imageNamed:@"icon-kefu"]];
    }else if (row == 3){
        [cell.titleLabel setText:@"退出账号"];
        [cell.mImageView setImage:[UIImage imageNamed:@"icon-tuichu"]];
        [cell.rightImage setHidden:YES];
        /*下圆角*/
        UIBezierPath *maskPath = [UIBezierPath bezierPathWithRoundedRect:CGRectMake(0, 0, SCREEN_W-30 , 60)
                                                       byRoundingCorners:UIRectCornerBottomLeft | UIRectCornerBottomRight
                                                             cornerRadii:CGSizeMake(8, 8)];
        CAShapeLayer *maskLayer = [[CAShapeLayer alloc] init];
        maskLayer.frame = cell.cellBgView.bounds;
        maskLayer.path = maskPath.CGPath;
        cell.bgViewLayer = maskLayer;
        cell.cellBgView.layer.mask = cell.bgViewLayer;
        
        [cell.lineView setHidden:YES];
    }

    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 60;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    NSInteger row = indexPath.row;
    
    if (2 == row){
        CustomerWebViewController *vc = [[CustomerWebViewController alloc] init];
        vc.titleStr = @"隐私空间客服";
        NSDictionary *dictLogin = [[UseAccountManage shareInstance] getLoginInfo];
        if (dictLogin && [[dictLogin allKeys] containsObject:@"token"])
        {
            NSString *tokenStr = [dictLogin objectForKey:@"token"];
            NSString *url = [NSString stringWithFormat:@"http://192.168.11.32:11180/cloud/privacy/#/pages/setup/online-customer-service?autoopen=true&token=%@", tokenStr];
//            if ([CloudService containsString:@"14.18.190.141:11180"]) { // 测试环境
//                url = [NSString stringWithFormat:@"http://testprivacy.phone.armclouding.com:11180/h5/customer-service?autoopen=true&token=%@", tokenStr];
//            }
            vc.webUrl = url;
            [self.navigationController pushViewController:vc animated:YES];
        }
    }else if (1 == row){
        AboutViewController *vc = [[AboutViewController alloc] init];
        [self.navigationController pushViewController:vc animated:YES];
    }
}

- (void)vipBtnPressed{
    CustomerWebViewController *vc = [[CustomerWebViewController alloc] init];
    vc.needHidenNav = YES;
    NSDictionary *dictLogin = [[UseAccountManage shareInstance] getLoginInfo];
    if (dictLogin && [[dictLogin allKeys] containsObject:@"token"])
    {
        NSString *tokenStr = [dictLogin objectForKey:@"token"];
        NSString *url = [NSString stringWithFormat:@"http://192.168.11.32:11180/cloud/privacy/#/pages/invitation/index?token=%@&iosVersionNumber=%@", tokenStr,[iPhone appVersion]];
        vc.webUrl = url;
        [self.navigationController pushViewController:vc animated:YES];
    }
}
@end
