//
//  CloudPhoneAuthModel.h
//  VclustersGemini
//
//  Created by APPLE on 2020/10/9.
//  Copyright © 2020 APPLE. All rights reserved.
//

#import "SuperModel.h"
#import "BGFMDB.h" //添加该头文件,本类就具有了存储功能.

NS_ASSUME_NONNULL_BEGIN

@interface PhoneP2PModel : SuperModel

@property(nonatomic,copy) NSString *sn;//设备物理唯一标识符

/**
 * @brief  云手机ip地址
 */
@property (nonatomic,copy) NSString *internetIp;

/**
 * @brief 机房外网ip （ping地址）
 */
@property (nonatomic,copy) NSString *roomInternetIp;

/**
 * @brief 业务通讯外网端口 （暂时未使用）
 */
@property (nonatomic, copy) NSString *internetBusinessPort;

/**
 * @brief  音视频外网端口
 */
@property (nonatomic,copy) NSString *internetVideoPort;

/**
 * @brief vpnStatus 1：开启    0：关闭
 */
@property (nonatomic, assign) NSInteger vpnStatus;

/**
 * @brief  虚拟按键状态 1：开启 0：关闭
 */
@property(nonatomic, assign)NSInteger virtualKeyStatus;

/**
 * @brief  云手机推流编码   H264 H265
 */
@property (nonatomic,copy) NSString *videoCode;

/**
 * @brief 板卡型号
 */
@property (nonatomic, copy) NSString *deviceBoard;

/**
 * @brief 机房外网wss地址
 */
@property (nonatomic, copy) NSString *internetHttps;

/**
 * @brief 机房外网ws地址
 */
@property (nonatomic, copy) NSString *internetHttp;

/**
 * @brief 安卓卡内网ws地址
 */
@property (nonatomic, copy) NSString *localIp;

/**
 * @brief 安卓卡校验token
 */
@property (nonatomic, copy) NSString *cardToken;

/**
 * @brief 推流编码（H264、H265）
 */
@property (nonatomic, copy) NSString *pushFlowCode;

/**
 * @brief 分辨率（720、1080）
 */
@property (nonatomic, copy) NSString *resolvingPower;

@property (nonatomic,assign) NSInteger ctime;//创建时间
@property (nonatomic,assign) NSInteger phoneId;//设备ID绑定用户唯一标识符

/**
 * @brief 分辨率高度
 */
@property (nonatomic,assign) NSInteger  high;/*高度*/

/**
 * @brief 分辨率宽度
 */
@property (nonatomic,assign) NSInteger  width;/*宽度*/

/**
 * @brief 分辨率密度
 */
@property (nonatomic,assign) NSInteger  dpi;/*密度*/

/**
 * @brief vpn模式 0：自动 1：UDP 2:TCP
 */
@property (nonatomic,assign) NSInteger  vpnMode;

@end


NS_ASSUME_NONNULL_END
