//
//  CloudPhoneModel.m
//  VclustersGemini
//
//  Created by APPLE on 2020/7/27.
//  Copyright © 2020 APPLE. All rights reserved.
//

#import "CloudPhoneModel.h"

@implementation CloudPhoneModel

/**
 自定义“联合主键” ,这里指定 phoneId 为“联合主键”.
 */
+(NSArray *)bg_unionPrimaryKeys{
    return @[@"phoneId"];
}

+(JSONKeyMapper *)keyMapper{
    return [[JSONKeyMapper alloc]initWithDictionary:@{@"id":@"phoneId"}];
}

- (id)init
{
    self = [super init];
    
    if (self)
    {
        self.areaStatus = SiteSwitchStateNormal;
        self.cardId = 0;
        self.freeTrial = @"20";
        self.getDeviceTime = [[NSDate date] timeIntervalSince1970];
        self.needUpdateImageInSever = NO;
        self.deviceRefeshImageTime = 0;
        self.sign = 0;
        self.period = 0;
        
        self.oneButtonStatus = -1;
        self.rootSwitchStatus = -1;
        self.virtualGpsStatus = -1;
        self.siteTransferStatus = -1;
        self.modifyCardParamStatus = -1;
        self.phoneCameraStatus = -1;
    }
    
    return self;
}

//是否开启虚拟键盘
- (BOOL)isOpenVirtualKey
{
    //初始化左手
    if (self.virtualKeyStatus == 1) {
        return YES;
    }
    else
    {
        return NO;
    }
}

/*专业模式处理*/
- (BOOL)isOpenUsageMode{
    if (self.usageMode == 1) {
        return YES;
    }
    else
    {
        return NO;
    }
}

- (BOOL)isOpenRoot
{
    //初始化Root开关
    if (self.rootStatus == 1) {
        return YES;
    }
    else
    {
        return NO;
    }
}

//是否开启左手
- (BOOL)isOpenLeftModel
{
    if (self.usageHabit == 1) { //使用习惯 1：左手 2：右手
        return YES;
    }
    else
    {
        return NO;
    }
}

@end

@implementation CloudPhoneListModel


@end

@implementation CloduPhoneListDataModel


@end

@implementation CloudPhoneListForRenewModel


@end

@implementation CloudPhoneDataModel


@end



