//
//  UseAccountManage.h
//  VclustersGemini
//
//  Created by APPLE on 2019/6/13.
//  Copyright © 2019 APPLE. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "AFHTTPSessionManager.h"
#import "CloudPhoneModel.h"

NS_ASSUME_NONNULL_BEGIN

@class SHMessage;

/**
 *  成功请求Block返回的字典
 */
typedef void (^Success) (id responseObject);

/**
 *  失败Block返回
 */
typedef void (^Faild) (NSError *error);

/**
 *  成功请求Block返回的字典
 */
typedef void (^SuccessSuperModel) (SuperModel *model);

#define CODE          [[responseObject objectForKey:@"status"] integerValue]
#define MSG           [NSString stringWithFormat:@"%@", [responseObject objectForKey:@"msg"]]

//基类request网络请求的回调
typedef void(^CloudServiceCompletionBlock) (NSError * _Nullable error , id  data);

@interface UseAccountManage : NSObject

@property (nonatomic,strong)AFHTTPSessionManager *manager;
@property (nonatomic,copy)NSString *mCloudService;
@property (nonatomic,copy)NSString *mRequstAPI;

@property (nonatomic,strong)CloudPhoneListModel *cloudPhoneListModel;

#pragma mark 分类UseAccountManage+LoginReg.h
@property (nonatomic,strong)NSMutableDictionary *useBaseInfo;
@property (nonatomic,strong)NSMutableDictionary *useLeftInfo;

+ (UseAccountManage *)shareInstance;

#pragma mark 网络请求 异常情况处理
/**系统繁忙*/
@property (nonatomic,strong) NSMutableDictionary *systemBusyDict;
/**网络异常*/
@property (nonatomic,strong) NSMutableDictionary *networkErrorDict;
/**异常情况处理*/
- (BOOL)isDidHandelCustomStatusFun:(id)responseObject task:(NSURLSessionDataTask *)task;
/** 设备已在别处登录*/
-(void)showLoginOutTip:(NSString*)msgStr;

#pragma mark 获取链接
#pragma mark 未处理请求头（请求接口前未提示设备在别处登录）
//Get
- (void)requestWithGetparameters:(NSDictionary*)parameters complteteBlock:(CloudServiceCompletionBlock)complteteBlock;

//POST 且处理异常状态码，需要另加异常闪退保存文件处理
- (void)requestWithPostparameters:(NSDictionary*)parameters complteteBlock:(CloudServiceCompletionBlock)complteteBlock;

//Put
- (void)requestWithPutparameters:(NSDictionary*)parameters complteteBlock:(CloudServiceCompletionBlock)complteteBlock;

//Delete
- (void)requestWithDeleteparameters:(NSDictionary*)parameters complteteBlock:(CloudServiceCompletionBlock)complteteBlock;

- (void)requestWithPatchparameters:(NSDictionary*)parameters complteteBlock:(CloudServiceCompletionBlock)complteteBlock;


#pragma mark hxd 重新封装 afnetwork  get 请求
- (void)commonGetCanWithOutTokenCallBackUrl:(NSString *)url Parameters:(NSDictionary *_Nullable)dic success:(Success)success failure:(Faild)faildStr;
- (void)CommonGetWithCallBackCode:(NSString *)code Parameters:(NSDictionary *_Nullable)dic success:(Success)success failure:(Faild)faildStr;
- (void)CommonYunPanGetWithCallBackCode:(NSString *)code Parameters:(NSDictionary *_Nullable)dic success:(Success)success failure:(Faild)faildStr;

- (void)CommonXinduoMineGetWithCallBackCode:(NSString *)code Parameters:(NSDictionary *_Nullable)dic type:(NSInteger)typeIndex success:(Success)success failure:(Faild)faildStr;
//星多二次访问
- (void)CommonXinduoGetWithCallBackCode:(NSString *)code Parameters:(NSDictionary *_Nullable)dic success:(Success)success failure:(Faild)faildStr;

#pragma mark hxd 重新封装 afnetwork  post 请求
- (void)CommonPostCallBackCode:(NSString*)code  Parameters:(NSDictionary *_Nullable)dict success:(Success)success failure:(Faild)failure;
- (void)CommonPostCallBackCode:(NSString*)code  Params:(id)dict success:(Success)success failure:(Faild)failure;
- (void)commonPostCanWithOutTokenCallBackCode:(NSString*)code  Parameters:(NSDictionary*)dict success:(Success)success failure:(Faild)failure;
- (void)CommonYunPanPostCallBackCode:(NSString*)code  Parameters:(NSDictionary*)dict success:(Success)success failure:(Faild)failure;

#pragma mark hxd 重新封装 afnetwork  put 请求
- (void)CommonPutCallBackCode:(NSString*)code  Parameters:(NSDictionary*)dict success:(Success)success failure:(Faild)failure;
- (void)commonPutCanWithoutTokenCallBackCode:(NSString*)code  Parameters:(NSDictionary*)dict success:(Success)success failure:(Faild)failure;

#pragma mark hxd 重新封装 afnetwork  delete 请求
- (void)CommonDeleteCallBackCode:(NSString*)code  Parameters:(NSDictionary *_Nullable)dict success:(Success)success failure:(Faild)failure;


// 清空Cookie
- (void)clearCookies;

/*外部传入连接请求数据*/
- (void)commonGetWithUrl:(NSString *)url Parameters:(NSDictionary *_Nullable)dic success:(Success)success failure:(Faild)faildStr;


//登出操作
- (BOOL)logout;

/**
 * @brief 设置登录信息
 *
 * @return 登录后保留的相关信息
 *
 */
- (BOOL)setLoginInfo:(NSDictionary *)loginInfo;


/**
 * @brief 获取登录信息
 *
 * @return 登录后保留的相关信息
 *
 */
- (NSDictionary*)getLoginInfo;

/**
 * @brief 保存当前设备漂浮窗位置信息
 *
 * @param  sn 设备唯一标识符
 *
 */
- (void)saveDviceDriftInfoWith:(CGFloat)pointx ponitY:(CGFloat)ponity hidden:(BOOL)hidden deviceSN:(NSString *)sn;

/**
 * @brief 保存当前设备漂浮窗位置信息
 *
 * @return  字典  字段pointx:x坐标  pointy:y坐标  hidden:是否隐藏
 *
 */
- (NSDictionary *)getDviceDriftInfoWithdeviceSN:(NSString *)sn;


#pragma mark - 超分
- (void)extensionCloudPhoneToGetDeviceStatesWithDeviceId:(NSInteger )deviceId coordinatesLat:(NSString *)coordinatesLat coordinatesLng:(NSString *)coordinatesLng success:(Success)success faild:(Faild)faildStr;

//获取云手机推流页面指令通道URL
- (NSString *)getInstructionsChannelUrlWithInternetHttp:(NSString *)internetHttp localIp:(NSString *)localIp cardToken:(NSString *)cardToken;

//获取云手机推流页面业务通道URL
- (NSString *)getBusinessChannelUrlWithInternetHttp:(NSString *)internetHttp localIp:(NSString *)localIp cardToken:(NSString *)cardToken;

/**
 * @brief 埋点
 *
 * @param  array 参数，埋点数据
 *
 *
 */
- (void)extensionPublicToBuryPointPostCallBackCode:(NSString*)code  Parameters:(NSMutableArray*)array success:(Success)success failure:(Faild)failure;

@end
NS_ASSUME_NONNULL_END
