//
//  BuryPointModel.h
//  VclustersGemini
//
//  Created by ypp on 2020/12/30.
//  Copyright © 2020 APPLE. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSInteger, VisitType) {
    VisitTypeDefault = 0,            //默认
    VisitTypeAgreement = 1,          //协议埋点 ：用户协议访问
    VisitTypeLogout = 2,             //注销埋点 ：用户注销访问
    VisitTypeRegister = 3,           //注册埋点 ：用户注册访问
    VisitTypePromotionDownload = 4,  //推广页下载埋点 ：推广页下载访问
    VisitTypePcDownload = 5,         //官网pc下载埋点 ：官网pc下载访问
    VisitTypeAndroidDownload = 6,    //官网android下载埋点：官网android下载访问
    VisitTypeIOSDownload = 7,        //官网ios下载埋点：官网ios下载访问
    VisitTypeEight = 8,              //
    VisitTypeRenewCloudDisk = 9,     //续费云盘埋点 ：续费云盘页面访问
    VisitTypeCloudIphone = 10,       //云手机埋点 ：云手机界面访问
    VisitTypeCloudDisk = 11,         //云盘埋点：云盘界面访问
    VisitTypeWelfareCommunity = 12,  //福利社区埋点 ：福利社区界面访问
    VisitTypeSignIn = 13,            //签到埋点：签到打卡功能访问
    VisitTypeNotice = 14,            //弹窗公告埋点：访问弹窗公告页面
    VisitTypeNetworkSpeed = 15,      //网络测速埋点 ：网络测速功能访问
    VisitTypeBackup = 16,            //备份还原埋点：备份还原功能使用
    VisitTypeSiteSwitch = 17,        //站点迁移埋点 ：站点迁移功能使用
    VisitTypeBuyCloudIphone = 18,    //购买云手机埋点 ：购买云手机页面访问
    VisitTypeRenewCloudIphone = 19,  //续费云手机埋点 ：续费云手机页面访问
    VisitTypeCloudDiskExpansion = 20,//扩容云盘埋点 ：扩容云盘页面访问
    VisitTypeStarStoreExpansion = 21,//扩容星盘埋点：扩容星盘页面访问
    VisitTypeBuyStarCoin = 22,       //购买星币埋点：购买星币页面访问
    VisitTypeWechatInvite = 23,      //微信邀请埋点：微信邀请页面访问
    VisitTypeQQInvite = 24,          //qq邀请埋点 ：qq邀请页面访问
    VisitTypeContactInvite = 25,     //通讯录邀请埋点：通讯录邀请页面访问
    VisitTypeAccountInvite = 26,     //双子星账号邀请埋点：双子星账号邀请页面访问
    VisitTypeCrash = 27,             //双子星崩溃日志
};

@interface BuryPointModel : NSObject

//事件记录的时间戳（毫秒数）
@property (nonatomic, copy)NSString *time;
//访问类型
@property (nonatomic, assign)VisitType visitType;
//当前事件用户名
@property (nonatomic, copy)NSString *userName;

//崩溃信息
@property (nonatomic, copy)NSString *exceptionInfo;

//埋点方法
+ (NSString *)buryPointModelWithString:(VisitType)visitType;

//崩溃方法
+ (NSString *)crashModelWithString:(NSString *)exceptionInfo;
@end

NS_ASSUME_NONNULL_END
