//
//  BuryPointModel.m
//  VclustersGemini
//
//  Created by ypp on 2020/12/30.
//  Copyright © 2020 APPLE. All rights reserved.
//

#import "BuryPointModel.h"
#import "UseAccountManage.h"
#import "MJExtension.h"

@implementation BuryPointModel

- (NSString *)time
{
    NSTimeInterval timeInterval = [[NSDate date] timeIntervalSince1970]*1000;
    return [NSString stringWithFormat:@"%ld",(long)timeInterval];
}

- (NSString *)userName
{
    NSString *username = @"";
    NSDictionary *dictLogin = [[UseAccountManage shareInstance] getLoginInfo];
    if (dictLogin && [[dictLogin allKeys] containsObject:@"userName"])
    {
        username = [dictLogin objectForKey:@"userName"];
    }
    return username;
}

//埋点方法
+ (NSString *)buryPointModelWithString:(VisitType)visitType
{
    BuryPointModel *model = [[BuryPointModel alloc] init];
    model.visitType = visitType;
    NSString *modeJsonString = [NSString stringWithFormat:@"%@__",[model mj_JSONString]];
    return modeJsonString;
}

//崩溃方法
+ (NSString *)crashModelWithString:(NSString *)exceptionInfo
{
    BuryPointModel *model = [[BuryPointModel alloc] init];
    model.visitType = VisitTypeCrash;
    model.exceptionInfo = exceptionInfo;
    NSString *modeJsonString = [NSString stringWithFormat:@"%@__",[model mj_JSONString]];
    return modeJsonString;
}

@end
