//
//  Domains.h
//  IOTCamera
//
//  Created by Felix on 2018/10/30.
//  Copyright © 2018 system. All rights reserved.
//

/**
 *  @brief App端访问服务器域名的白名单文件，所有需要访问的域名全在此类进行添加。
 *         本类使用单例模式进行包装，方便域名白名单的全局管理和统一性。
 */


#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface Domains : NSObject <NSCopying>

@property (nonatomic, strong, readonly) NSArray *domains;

+ (instancetype)sharedInstance;

- (NSArray *)domains;

@end

NS_ASSUME_NONNULL_END
