//
//  Domains.m
//  IOTCamera
//
//  Created by Felix on 2018/10/30.
//  Copyright © 2018 system. All rights reserved.
//

#import "Domains.h"

static Domains *_instance = nil;

@implementation Domains {
    NSArray *_domains;
}

+ (instancetype)sharedInstance {
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        _instance = [[Domains alloc] init];
    });
    return _instance;
}

+ (instancetype)allocWithZone:(struct _NSZone *)zone {
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        _instance = [super allocWithZone:zone];
    });
    return _instance;
}

- (instancetype)copyWithZone:(NSZone *)zone {
    return _instance;
}

- (instancetype)init {
    if (self = [super init]) {
        [self initialized];
    }
    return self;
}

- (void)initialized {
    _domains = @[
                @"prod.ysx.optjoy.io",
                @"prod.ipc.ysx.optjoy.io",
                @"stag.ysx.optjoy.io",
                @"stag.ipc.ysx.optjoy.io",
                @"dev.ysx.optjoy.io",
                @"dev.ipc.ysx.optjoy.io",
                @"prod.ysx.optjoy.cn",
                @"prod.ipc.ysx.optjoy.cn",
                @"stag.ysx.optjoy.cn",
                @"stag.ipc.ysx.optjoy.cn",
                @"dev.ysx.optjoy.cn",
                @"dev.ipc.ysx.optjoy.cn",
                @"dada.p.optjoy.io",
                @"ipc.dada.p.optjoy.io",
                @"dada.s.optjoy.io", // QA
                @"ipc.dada.s.optjoy.io",
                @"dada.d.optjoy.io",
                @"ipc.dada.d.optjoy.io"];
}

- (NSArray *)domains {
    return [_domains copy];
}

@end
