//
//  HWBuryPointModel.h
//  VclustersGemini
//
//  Created by 余衡武 on 2022/6/21.
//  Copyright © 2022 APPLE. All rights reserved.
//

#import <Foundation/Foundation.h>
/**在需要存储的model类中,添加BGFMDB.h头文件,本类就具有了BGFMDB存储功能.*/
#import "BGFMDB.h"

#pragma mark - 事件编码
// 定义一个EventCodeType的字符串类型作为枚举类型
typedef NSString *EventCodeType NS_STRING_ENUM;
// 声明以下埋点类型EventCodeType枚举值
FOUNDATION_EXPORT EventCodeType const EventCodeTypeRegist;                     // 1_注册流程
FOUNDATION_EXPORT EventCodeType const EventCodeTypeLogin ;                     // 2_登录流程
FOUNDATION_EXPORT EventCodeType const EventCodeTypeTrial;                      // 3_试用流程
FOUNDATION_EXPORT EventCodeType const EventCodeTypeCloudPhoneRenew;            // 4_续费流程
FOUNDATION_EXPORT EventCodeType const EventCodeTypeCloudPhoneHomeFunction;     // 5_预览_功能使用
FOUNDATION_EXPORT EventCodeType const EventCodeTypeCloudPhoneBuy;              // 5_云手机购买流程
FOUNDATION_EXPORT EventCodeType const EventCodeTypeCloudStoreBuy;              // 6_云盘购买流程
FOUNDATION_EXPORT EventCodeType const EventCodeTypeStarCoinBuy;                // 7_星币购买流程
FOUNDATION_EXPORT EventCodeType const EventCodeTypeServiceBuy;                 // 8_云机服务购买流程
FOUNDATION_EXPORT EventCodeType const EventCodeTypeCloudPhoneList;             // 9_列表页使用
FOUNDATION_EXPORT EventCodeType const EventCodeTypeCloudPhoneListFunction;     // 10_列表_功能使用
FOUNDATION_EXPORT EventCodeType const EventCodeTypeCloudStoreFunction;         // 11_云盘操作次数
FOUNDATION_EXPORT EventCodeType const EventCodeTypeMineInfo;                   // 12_编辑个人中心
FOUNDATION_EXPORT EventCodeType const EventCodeTypeClickStarCoin;              // 13_查看星币
FOUNDATION_EXPORT EventCodeType const EventCodeTypeClickCoupon;                // 14_使用卡券
FOUNDATION_EXPORT EventCodeType const EventCodeTypeCustomerCenter;             // 15_客服中心
FOUNDATION_EXPORT EventCodeType const EventCodeTypeUseActiveCode;              // 16_使用激活码
FOUNDATION_EXPORT EventCodeType const EventCodeTypeToolCenter;                 // 17_查看工具中心
FOUNDATION_EXPORT EventCodeType const EventCodeTypeMessageCenter;              // 18_查看消息中心
FOUNDATION_EXPORT EventCodeType const EventCodeTypeAuthorCenter;               // 19_授权服务
FOUNDATION_EXPORT EventCodeType const EventCodeTypeOrderRecord;                // 20_购买记录
FOUNDATION_EXPORT EventCodeType const EventCodeTypeClickService;               // 21_查看云机服务
FOUNDATION_EXPORT EventCodeType const EventCodeTypeFriendFunction;             // 22_使用好友功能
FOUNDATION_EXPORT EventCodeType const EventCodeTypeSystemSet;                  // 23_系统设置
FOUNDATION_EXPORT EventCodeType const EventCodeTypeCloudPhonePushEvent;        // 24_推流事件
FOUNDATION_EXPORT EventCodeType const EventCodeTypeSMSLogin;                   // 25_验证码登录
FOUNDATION_EXPORT EventCodeType const EventCodeTypeAdvert;                     // 26_广告
FOUNDATION_EXPORT EventCodeType const EventCodeTypeRenewTime;                  // 27_续时长
FOUNDATION_EXPORT EventCodeType const EventCodeTypeAppDownLoad;
FOUNDATION_EXPORT EventCodeType const EventCodeTypeTimeRemind;
FOUNDATION_EXPORT EventCodeType const EventCodeTypePhoneStream;
FOUNDATION_EXPORT EventCodeType const EventCodeTypeBuyPhone;
FOUNDATION_EXPORT EventCodeType const EventCodeTypeHomeBottomWelFare;
FOUNDATION_EXPORT EventCodeType const EventCodeTypeHomeBottomMy;
FOUNDATION_EXPORT EventCodeType const EventCodeTypeHomeBottomChat;
FOUNDATION_EXPORT EventCodeType const EventCodeTypeHomeBottomCustom;
FOUNDATION_EXPORT EventCodeType const EventCodeTypeHomeBottomPhone;
FOUNDATION_EXPORT EventCodeType const EventCodeTypeHomeBottomStore;

#pragma mark 游客模式
FOUNDATION_EXPORT EventCodeType const EventCodeTypeBindPhoneEnterPhone;//41_进入云机_绑定手机号";
FOUNDATION_EXPORT EventCodeType const EventCodeTypeBindPhoneExtension;//42_拓展服务_绑定手机号";
FOUNDATION_EXPORT EventCodeType const EventCodeTypeVisitorLogin;//游客模式

FOUNDATION_EXPORT EventCodeType const EventCodeTypeYearCardBuy;//年卡购买流程

#pragma mark - 点击按钮编码
// 定义一个ClickButtonType的字符串类型作为枚举类型
typedef NSString *ClickButtonType NS_STRING_ENUM;
// 声明以下埋点类型ClickButtonType枚举值

#pragma mark tabbar
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTabbarBottomPhone;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTabbarBottomMy;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTabbarBottomWelFare;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTabbarBottomChat;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTabbarBottomCustom;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTabbarBottomStore;

#pragma mark 续时长
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRenewTimeOneHour;     // 续时长-1小时套餐
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRenewTimeTenHour;     // 续时长-10小时套餐
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRenewTimeWXPay;       // 续时长-WX支付
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRenewTimeZFBPay;      // 续时长-ZFB支付
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRenewTimeBuy;         // 续时长-购买
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRenewTimeBack;        // 续时长-返回

#pragma mark 注册
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistRegist;     // 注册-注册
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistLoginSMS;   // 注册-验证码登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistLoginWX;    // 注册-WX登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistLoginQQ;    // 注册-QQ登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistLoginApple; // 注册-Apple登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistLogin;      // 注册-登录按钮
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistPhoneNum;   // 注册-输入手机号
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistSMSCode;    // 注册-输入验证码
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistOnekeyLogin; // 注册-一键登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistGetSMS;//注册-获取验证码
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistInPutPWD;//注册-输入密码
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRegistInPutInviteCode;//注册-邀请码

#pragma mark 登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeLoginPWD;         // 登录-登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeLoginSMS;         // 登录-验证码登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeLoginWX;          // 登录-WX登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeLoginQQ;          // 登录-QQ登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeLoginApple;       // 登录-Apple登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeLoginForgetPWD;   // 登录-忘记密码
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeLoginPhoneNum;    // 登录-输入手机号
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeLoginPWDCode;     // 登录-输入密码

#pragma mark 验证码登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSMSLoginPhoneNum;    // 验证码登录-输入手机号
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSMSLoginGetSMS;      // 验证码登录-获取验证码
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSMSLoginResendSMS;   // 验证码登录-重新发送
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSMSLoginVisitor;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSMSLoginOneKeyLogin;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSMSLoginAccountLogin;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSMSLoginWXLogin;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSMSLoginQQLogin;

#pragma mark 一键登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeOneKeyLogin;      // 登录-一键登录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeOneKeyLoginBack;  // 登录-一键登录返回
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorLogin;   //一键登录中的游客模式

#pragma mark 云手机试用
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTrialXingDong;    // 试用-星动云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTrialXingYao;     // 试用-星曜云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTrialWuJi;        // 试用-唔即云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTrialWuJiPRO;     // 试用-唔即PRO云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTrialFreeUse;     // 试用-免费试用云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTrialCancelQueue; // 试用-退出排队
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTrialStartUse;    // 试用-开始试用
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTrialCancelUse;   // 试用-取消试用

#pragma mark 云手机续费
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonRenewBtnClick;    // 续费-云手机续费
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonRenewCount;       // 续费-云手机数量
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonRenewPayType;     // 续费-支付方式
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonRenewClickBuy;    // 续费-购买
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonRenewClickBack;   // 续费-返回
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonRenewCoupon; //续费_优惠券

#pragma mark 云手机功能
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneRestart;        // 云手机功能-系统重启
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneReset;          // 云手机功能-恢复出厂
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneReName;         // 云手机功能-重命名
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneSystemUpgrade;  // 云手机功能-系统升级
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneAuthorManager;  // 云手机功能-授权管理
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneReplacePhone;   // 云手机功能-一键换机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneCamera;         // 云手机功能-云机摄像头
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonePackageUpgrade;//Cloudphone_功能_套餐升级";
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneOneKeyRepair;//"Cloudphone_功能_一键恢复";
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneRoot;//"Cloudphone_功能_ROOT开关";

#pragma mark 云手机购买
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneXingDong;     // 购买云手机-星动云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneXingYao;      // 购买云手机-星曜云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneWuJi;         // 购买云手机-唔即云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneWuJiPRO;      // 购买云手机-唔即PRO云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneZVIP;         // 购买云手机-唔即ZVIP云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneCoupon;       // 购买云手机-优惠券
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneWX;           // 购买云手机-微信
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneZFB;          // 购买云手机-支付宝
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneXB;           // 购买云手机-星币
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneClickBuy;     // 购买云手机-购买
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneClickBack;    // 购买云手机-返回
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneAndroid7;     // 购买云手机-选择安卓7
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneAndroid10;    // 购买云手机-选择安卓10

#pragma mark 云盘购买
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudStoreWX;           // 购买云盘-微信
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudStoreZFB;          // 购买云盘-支付宝
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudStoreXB;           // 购买云盘-星币
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudStoreClickBuy;     // 购买云盘-购买
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudStoreClickBack;    // 购买云盘-返回

#pragma mark 星币购买
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyStarCoinCoupon;       // 购买星币-优惠券
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyStarCoinWX;           // 购买星币-微信
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyStarCoinZFB;          // 购买星币-支付宝
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyStarCoinClickBuy;     // 购买星币-购买
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyStarCoinClickBack;    // 购买星币-返回

#pragma mark 云机服务购买
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneServiceReplacePhone; // 购买云机服务-一键换机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneServiceCamera;       // 购买云机服务-云机摄像头
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneServiceWX;           // 购买云机服务-微信
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneServiceZFB;          // 购买云机服务-支付宝
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneServiceXB;           // 购买云机服务-星币
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneServiceBuy;           //buy_云机服务_购买
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyCloudPhoneServiceBack;          //buy_云机服务_返回

#pragma mark 云手机列表
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneListSearch;         // 云手机列表-搜索
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneListRenew;          // 云手机列表-续费
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneListOff;            // 云手机列表-下机

#pragma mark 云手机推流
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonePushEnter;         // 云手机推流-进入云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonePushSwitch;        // 云手机推流-切换设备
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonePushScreenShot;    // 云手机推流-截图
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonePushShortcut;      // 云手机推流-添加桌面
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhonePushExit;          // 云手机推流-退出

#pragma mark HWTopView-按钮
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneListBtnClick;       // HWTopView-列表
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudPhoneBuyBtnClick;        // HWTopView-购买

#pragma mark 云盘
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreClickRenew;       // 云盘-续费入口
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreContact;          // 云盘-通讯录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreUploadFile;       // 云盘-上传文件
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreAddStoreClick;    // 云盘-去扩容
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreAddStoreCancel;   // 云盘-去扩容_取消
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreCreatDirectory;   // 云盘-新建目录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreTransferList;     // 云盘-传输列表
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreUploadList;       // 云盘-上传列表
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreDownloadList;     // 云盘-下载列表
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreBrowser;          // 云盘-最近浏览
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreSearch;           // 云盘-搜索功能
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCloudStoreFunction;         // 云盘-云盘功能键

#pragma mark 我的
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineInfo;                // 我的-编辑个人信息
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineInfoClickPhone;//Personal_phone_手机号";
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineInfoInputPhone;//Personal_phone_输入手机号";
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineInfoClickSMS;//Personal_phone_获取验证码";
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineInfoInputSMS;//Personal_phone_输入验证码";

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineStarCoin;            // 我的-星币
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineCoupon;              // 我的-卡券
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineCouponUse;           // 我的-优惠券-去使用
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineClickCoupon;         // 我的-卡券-优惠券
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineClickActiveCode;     // 我的-卡券-激活码
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineActiveCodeUse;       // 我的-卡券-激活码去使用

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineCustomerCenter;      // 我的-客服中心
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineActiveCode;          // 我的-激活码
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineToolCenter;          // 我的-工具中心
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineMessageCenter;       // 我的-消息中心
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineAuthorCenter;        // 我的-授权中心
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineOrderRecord;         // 我的-购买记录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineCloudPhoneService;   // 我的-云机服务
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineFriend;              // 我的-好友
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeMineSystemSet;           // 我的-系统设置

#pragma mark 问题反馈
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCustomerCenterFeedback;        // 问题反馈-问题反馈
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCustomerCenterNormal;          // 问题反馈-常见问题
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCustomerCenterQQ;              // 问题反馈-QQ客服
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCustomerCenterQQqun;           // 问题反馈-QQ群
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCustomerCenterPhone;           // 问题反馈-客服热线

#pragma mark 激活码
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeActiveCodeTextField;        // 激活码-激活码兑换
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeActiveCodeExchange;        // 激活码-兑换

#pragma mark 工具中心
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeToolCenterAutoRenew;        // 工具中心-自动续费管理
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeToolCenterNetwork;          // 工具中心-网络测速

#pragma mark 授权管理
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeAuthorSet;              // 授权管理-设置授权
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeAuthorRecord;           // 授权管理-授权记录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeAuthorSure;             // 授权管理-确认
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeAuthorBindPhone;           // 授权管理-立即绑定
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeAuthorBindCancel;             // 授权管理-关闭

#pragma mark 购买记录
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeOrderRecordCancel;        // 购买记录-取消订单
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeOrderRecordPay;           // 购买记录-去支付

#pragma mark 好友
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeFriendAdd;          // 好友-加好友
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeFriendWX;           // 好友-微信好友
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeFriendContact;      // 好友-通讯录好友
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeFriendQQ;           // 好友-qq好友
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeFriendSendPicture;  // 好友-发送图片
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeFriendSendVideo;    // 好友-发送小视频
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeFriendSendFile;     // 好友-发送文件
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeFriendAuthPhone;    // 好友-授权云手机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeFriendBindPhone;//Personal_firend_立即绑定";
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeFriendBindCancel;//Personal_firend_关闭";

#pragma mark 系统设置
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSystemSetChangePWD;          // 系统设置-修改密码
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSystemSetDestroyAccount;     // 系统设置-注销账号
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSystemSetExchangeAccount;    // 系统设置-切换账号
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSystemSetLogout;             // 系统设置-退出登录账号
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSystemSetBack;               // 系统设置-返回

#pragma mark 广告
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeADNoTipsToday;             // 首页弹窗广告-当日不在提示
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeADNoTips;                  // 首页弹窗广告-不在提示
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeADClickBtn;                // 首页弹窗广告-点击悬浮按钮
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeADClickAD;                 // 首页弹窗广告-点击弹窗广告
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeADClose;                   // 首页弹窗广告-关闭弹窗广告

#pragma mark 应用推荐
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeAppDownLoad;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeAppExchangeOther;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeAppRemindClosed;

#pragma mark 计时埋点
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeTimeCount;

#pragma mark 推流事件
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeChangePhone;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeScreenShot;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeAddDesk;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeExitPhone;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeExitAndClosePhone;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeResolution;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeSysResloution;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeConnectModel;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeCopy;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVR;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeLeftModel;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeRootKey;

#pragma mark 购买云机
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeBuyRedsTime;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelInPhone;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelInPhoneBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelInPhoneCancel;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelExtention;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelExtentionBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelExtentionCancel;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelListInPhone;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelListInPhoneBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelListInPhoneCancel;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelListExtention;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelListExtentionBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelListExtentionCancel;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelWelFareBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelWelFareCancel;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelWelFareBuyPhone;

#pragma mark 福利社区
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeWelFareGFZX;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeWelFareYXFL;

#pragma mark 游客模式
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorlginRegister;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorlginPhoneLogin;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorlginLogin;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorlginAccountLogin;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorlginLoginWX;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorlginLoginQQ;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelExchangeBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelExchangeCancel;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelExchangeYearCardBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelExchangeYearCardCancel;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelExchangeStoreBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelExchangeStoreCancel;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelBuyPhoneBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelBuyPhoneCancel;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelBuyStoreBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelBuyStoreCancel;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelBuyServerBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelBuyServerCancel;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelBuyYearCardBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelBuyYearCardCancel;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelBuyStarCoinBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelBuyStarCoinCancel;

FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelActiveExchangeBind;
FOUNDATION_EXPORT ClickButtonType const ClickButtonTypeVisitorModelActiveExchangeCancel;
#pragma mark - model属性
@interface HWBuryPointModel : NSObject

/**设备类型 2:苹果*/
@property (nonatomic, copy)  NSString *client;
/**事件编码*/
@property (nonatomic, copy)  NSString *eventCode;
/**事件结果 - 可选字段 （部分埋点事件需要）*/
@property (nonatomic, copy)  NSString *eventResult;
/**机型*/
@property (nonatomic, copy)  NSString *model;
/**操作时间*/
@property (nonatomic, copy)  NSString *operationTime;
/**埋点按钮*/
@property (nonatomic, copy)  NSString *positionButton;
/**埋点页*/
@property (nonatomic, copy)  NSString *positionPage;
/**用户名*/
@property (nonatomic, copy)  NSString *userName;
/**版本信息*/
@property (nonatomic, copy)  NSString *version;
/**操作系统版本号*/
@property (nonatomic, copy)  NSString *systemVersion;

/**设备唯一标识符*/
@property (nonatomic, copy)  NSString *deviceId;

/**手机当前ip*/
@property (nonatomic, copy)  NSString *ip;

/**当前登录账号*/
@property (nonatomic, copy)  NSString *phoneNumber;

#pragma mark - 埋点model构造方法
/**埋点model构造方法*/
+ (HWBuryPointModel *)buryPointWithEventType:(EventCodeType)eventCodeType buttonType:(ClickButtonType)clickButtonType;

/**广告点击埋点model构造方法*/
+ (HWBuryPointModel *)buryPointWithEventType:(EventCodeType)eventCodeType adPlaceID:(NSInteger)adPlaceID adID:(NSString *)adID;

@end


