//
//  HWBuryPointModel.m
//  VclustersGemini
//
//  Created by 余衡武 on 2022/6/21.
//  Copyright © 2022 APPLE. All rights reserved.
//

#import "HWBuryPointModel.h"
#import "iPhone.h"
#import "UseAccountManage.h"
#import "iTools.h"

#pragma mark - 事件编码
NSString *const EventCodeTypeRegist                       = @"1_注册流程";
NSString *const EventCodeTypeLogin                        = @"2_登录流程";
NSString *const EventCodeTypeTrial                        = @"3_试用流程";
NSString *const EventCodeTypeCloudPhoneRenew              = @"4_续费流程";
NSString *const EventCodeTypeCloudPhoneHomeFunction       = @"5_预览_功能使用";
NSString *const EventCodeTypeCloudPhoneBuy                = @"5_云手机购买流程";
NSString *const EventCodeTypeCloudStoreBuy                = @"6_云盘购买流程";
NSString *const EventCodeTypeStarCoinBuy                  = @"7_星币购买流程";
NSString *const EventCodeTypeServiceBuy                   = @"8_云机服务购买流程";
NSString *const EventCodeTypeCloudPhoneList               = @"9_列表页使用";
NSString *const EventCodeTypeCloudPhoneListFunction       = @"10_列表_功能使用";
NSString *const EventCodeTypeCloudStoreFunction           = @"11_云盘操作次数";
NSString *const EventCodeTypeMineInfo                     = @"12_编辑个人中心";
NSString *const EventCodeTypeClickStarCoin                = @"13_查看星币";
NSString *const EventCodeTypeClickCoupon                  = @"14_使用卡券";
NSString *const EventCodeTypeCustomerCenter               = @"15_客服中心";
NSString *const EventCodeTypeUseActiveCode                = @"16_使用激活码";
NSString *const EventCodeTypeToolCenter                   = @"17_查看工具中心";
NSString *const EventCodeTypeMessageCenter                = @"18_查看消息中心";
NSString *const EventCodeTypeAuthorCenter                 = @"19_授权服务";
NSString *const EventCodeTypeOrderRecord                  = @"20_购买记录";
NSString *const EventCodeTypeClickService                 = @"21_查看云机服务";
NSString *const EventCodeTypeFriendFunction               = @"22_使用好友功能";
NSString *const EventCodeTypeSystemSet                    = @"23_系统设置";
NSString *const EventCodeTypeCloudPhonePushEvent          = @"24_推流事件";
NSString *const EventCodeTypeSMSLogin                     = @"25_验证码登录";
NSString *const EventCodeTypeAdvert                       = @"26_广告";
NSString *const EventCodeTypeRenewTime                    = @"27_续时长";
NSString *const EventCodeTypeAppDownLoad                  = @"28_应用下载";
NSString *const EventCodeTypeTimeRemind                   = @"29_计时提醒";
NSString *const EventCodeTypePhoneStream                  = @"30_推流事件";
NSString *const EventCodeTypeBuyPhone                     = @"37_购买云手机";

NSString *const EventCodeTypeHomeBottomWelFare            = @"33_进入福利社区";
NSString *const EventCodeTypeHomeBottomMy                 = @"35_进入我的";
NSString *const EventCodeTypeHomeBottomChat               = @"34_进入好友";
NSString *const EventCodeTypeHomeBottomCustom             = @"36_客服";
NSString *const EventCodeTypeHomeBottomPhone              = @"32_进入首页";
NSString *const EventCodeTypeHomeBottomStore              = @"37_云盘";
NSString *const EventCodeTypeBindPhoneEnterPhone          = @"41_进入云机_绑定手机号";
NSString *const EventCodeTypeBindPhoneExtension           = @"42_拓展服务_绑定手机号";
NSString *const EventCodeTypeVisitorLogin                 = @"43_游客登录";
NSString *const EventCodeTypeYearCardBuy                  = @"44_特权年卡购买流程";
#pragma mark - 点击按钮编码

/*tabbar*/
NSString *const ClickButtonTypeTabbarBottomPhone        = @"bottom_云手机";
NSString *const ClickButtonTypeTabbarBottomMy           = @"bottom_我的";
NSString *const ClickButtonTypeTabbarBottomWelFare      = @"bottom_福利社区";
NSString *const ClickButtonTypeTabbarBottomChat         = @"bottom_好友";
NSString *const ClickButtonTypeTabbarBottomCustom       = @"bottom_客服";
NSString *const ClickButtonTypeTabbarBottomStore        = @"bottom_云盘";

#pragma mark 续时长
NSString *const ClickButtonTypeRenewTimeOneHour          = @"xushichang_1小时套餐";
NSString *const ClickButtonTypeRenewTimeTenHour          = @"xushichang_10小时套餐";
NSString *const ClickButtonTypeRenewTimeWXPay            = @"xushichang_微信";
NSString *const ClickButtonTypeRenewTimeZFBPay           = @"xushichang_支付宝";
NSString *const ClickButtonTypeRenewTimeBuy              = @"xushichang_购买";
NSString *const ClickButtonTypeRenewTimeBack             = @"xushichang_返回";

#pragma mark 注册
NSString *const ClickButtonTypeRegistRegist          = @"register_注册";
NSString *const ClickButtonTypeRegistLoginSMS        = @"register_验证码登录";
NSString *const ClickButtonTypeRegistLoginWX         = @"register_微信登录";
NSString *const ClickButtonTypeRegistLoginQQ         = @"register_QQ登录";
NSString *const ClickButtonTypeRegistLoginApple      = @"register_Apple登录";
NSString *const ClickButtonTypeRegistLogin           = @"register_登录";
NSString *const ClickButtonTypeRegistPhoneNum        = @"register_输入手机号";
NSString *const ClickButtonTypeRegistSMSCode         = @"register_输入验证码";
NSString *const ClickButtonTypeRegistOnekeyLogin     = @"register_一键登录";
NSString *const ClickButtonTypeRegistGetSMS          = @"register_获取验证码";
NSString *const ClickButtonTypeRegistInPutPWD        = @"register_输入密码";
NSString *const ClickButtonTypeRegistInPutInviteCode = @"register_邀请码";

#pragma mark 登录
NSString *const ClickButtonTypeLoginPWD              = @"record_登录";
NSString *const ClickButtonTypeLoginSMS              = @"record_验证码登录";
NSString *const ClickButtonTypeLoginWX               = @"record_微信登录";
NSString *const ClickButtonTypeLoginQQ               = @"record_QQ登录";
NSString *const ClickButtonTypeLoginApple            = @"record_Apple登录";
NSString *const ClickButtonTypeLoginForgetPWD        = @"record_忘记密码";
NSString *const ClickButtonTypeLoginPhoneNum         = @"record_输入手机号";
NSString *const ClickButtonTypeLoginPWDCode          = @"record_输入密码";

#pragma mark 验证码登录
NSString *const ClickButtonTypeSMSLoginPhoneNum      = @"phonerecord_输入手机号";
NSString *const ClickButtonTypeSMSLoginGetSMS        = @"phonerecord_获取验证码";
NSString *const ClickButtonTypeSMSLoginResendSMS     = @"phonerecord_重新发送";
NSString *const ClickButtonTypeSMSLoginVisitor       = @"phonerecord_游客登录";
NSString *const ClickButtonTypeSMSLoginOneKeyLogin   = @"phonerecord_一键登录";
NSString *const ClickButtonTypeSMSLoginAccountLogin  = @"phonerecord_账号登录";
NSString *const ClickButtonTypeSMSLoginWXLogin       = @"phonerecord_微信登录";
NSString *const ClickButtonTypeSMSLoginQQLogin       = @"phonerecord_QQ登录";


#pragma mark 一键登录
NSString *const ClickButtonTypeOneKeyLogin           = @"record_一键登录";
NSString *const ClickButtonTypeOneKeyLoginBack       = @"record_返回";
NSString *const ClickButtonTypeVisitorLogin          = @"record_游客登录";

#pragma mark 云手机试用
NSString *const ClickButtonTypeTrialXingDong         = @"Cloudphone_星动";
NSString *const ClickButtonTypeTrialXingYao          = @"Cloudphone_星曜";
NSString *const ClickButtonTypeTrialWuJi             = @"Cloudphone_唔即";
NSString *const ClickButtonTypeTrialWuJiPRO          = @"Cloudphone_唔即PRO";
NSString *const ClickButtonTypeTrialFreeUse          = @"Cloudphone_免费试用云手机";
NSString *const ClickButtonTypeTrialCancelQueue      = @"Cloudphone_退出排队";
NSString *const ClickButtonTypeTrialStartUse         = @"Cloudphone_开始试用";
NSString *const ClickButtonTypeTrialCancelUse        = @"Cloudphone_取消试用";

#pragma mark 云手机续费
NSString *const ClickButtonTypeCloudPhonRenewBtnClick      = @"Cloudphone_续费";
NSString *const ClickButtonTypeCloudPhonRenewCount         = @"Cloudphone_续费_续费手机数量";
NSString *const ClickButtonTypeCloudPhonRenewPayType       = @"Cloudphone_续费_支付方式";
NSString *const ClickButtonTypeCloudPhonRenewClickBuy      = @"Cloudphone_续费_购买";
NSString *const ClickButtonTypeCloudPhonRenewClickBack     = @"Cloudphone_续费_返回";
NSString *const ClickButtonTypeCloudPhonRenewCoupon        = @"Cloudphone_续费_优惠券";

#pragma mark 云手机首页功能
NSString *const ClickButtonTypeCloudPhoneRestart           = @"Cloudphone_功能_系统重启";
NSString *const ClickButtonTypeCloudPhoneReset             = @"Cloudphone_功能_恢复出厂";
NSString *const ClickButtonTypeCloudPhoneReName            = @"Cloudphone_功能_重命名";
NSString *const ClickButtonTypeCloudPhoneSystemUpgrade     = @"Cloudphone_功能_系统升级";
NSString *const ClickButtonTypeCloudPhoneAuthorManager     = @"Cloudphone_功能_授权管理";
NSString *const ClickButtonTypeCloudPhoneReplacePhone      = @"Cloudphone_功能_一键换机";
NSString *const ClickButtonTypeCloudPhoneCamera            = @"Cloudphone_功能_云机摄像头";
NSString *const ClickButtonTypeCloudPhonePackageUpgrade    = @"Cloudphone_功能_套餐升级";
NSString *const ClickButtonTypeCloudPhoneOneKeyRepair      = @"Cloudphone_功能_一键恢复";
NSString *const ClickButtonTypeCloudPhoneRoot              = @"Cloudphone_功能_ROOT开关";

#pragma mark 云手机购买
NSString *const ClickButtonTypeBuyCloudPhoneXingDong           = @"buy_云手机_星动";
NSString *const ClickButtonTypeBuyCloudPhoneXingYao            = @"buy_云手机_星曜";
NSString *const ClickButtonTypeBuyCloudPhoneWuJi               = @"buy_云手机_唔即";
NSString *const ClickButtonTypeBuyCloudPhoneWuJiPRO            = @"buy_云手机_唔即PRO";
NSString *const ClickButtonTypeBuyCloudPhoneZVIP               = @"buy_云手机_ZVIP";
NSString *const ClickButtonTypeBuyCloudPhoneCoupon             = @"buy_云手机_优惠券";
NSString *const ClickButtonTypeBuyCloudPhoneWX                 = @"buy_云手机_微信";
NSString *const ClickButtonTypeBuyCloudPhoneZFB                = @"buy_云手机_支付宝";
NSString *const ClickButtonTypeBuyCloudPhoneXB                 = @"buy_云手机_星币";
NSString *const ClickButtonTypeBuyCloudPhoneClickBuy           = @"buy_云手机_购买";
NSString *const ClickButtonTypeBuyCloudPhoneClickBack          = @"buy_云手机_返回";
NSString *const ClickButtonTypeBuyCloudPhoneAndroid7           = @"buy_选择安卓7";
NSString *const ClickButtonTypeBuyCloudPhoneAndroid10          = @"buy_选择安卓10";

#pragma mark 云盘购买
NSString *const ClickButtonTypeBuyCloudStoreWX                 = @"buy_云盘_微信";
NSString *const ClickButtonTypeBuyCloudStoreZFB                = @"buy_云盘_支付宝";
NSString *const ClickButtonTypeBuyCloudStoreXB                 = @"buy_云盘_星币";
NSString *const ClickButtonTypeBuyCloudStoreClickBuy           = @"buy_云盘_购买";
NSString *const ClickButtonTypeBuyCloudStoreClickBack          = @"buy_云盘_返回";

#pragma mark 星币购买
NSString *const ClickButtonTypeBuyStarCoinCoupon             = @"buy_星币_优惠券";
NSString *const ClickButtonTypeBuyStarCoinWX                 = @"buy_星币_微信";
NSString *const ClickButtonTypeBuyStarCoinZFB                = @"buy_星币_支付宝";
NSString *const ClickButtonTypeBuyStarCoinClickBuy           = @"buy_星币_购买";
NSString *const ClickButtonTypeBuyStarCoinClickBack          = @"buy_星币_返回";

#pragma mark 云机服务购买
NSString *const ClickButtonTypeBuyCloudPhoneServiceReplacePhone       = @"buy_云机服务_一键换机";
NSString *const ClickButtonTypeBuyCloudPhoneServiceCamera             = @"buy_云机服务_云机摄像头";
NSString *const ClickButtonTypeBuyCloudPhoneServiceWX                 = @"buy_云机服务_微信";
NSString *const ClickButtonTypeBuyCloudPhoneServiceZFB                = @"buy_云机服务_支付宝";
NSString *const ClickButtonTypeBuyCloudPhoneServiceXB                 = @"buy_云机服务_星币";
NSString *const ClickButtonTypeBuyCloudPhoneServiceBuy                = @"buy_云机服务_购买";
NSString *const ClickButtonTypeBuyCloudPhoneServiceBack               = @"buy_云机服务_返回";

#pragma mark 云手机列表-功能
NSString *const ClickButtonTypeCloudPhoneListSearch            = @"list_搜索框";
NSString *const ClickButtonTypeCloudPhoneListRenew             = @"list_续费";
NSString *const ClickButtonTypeCloudPhoneListOff               = @"list_下机";

#pragma mark 云手机推流
NSString *const ClickButtonTypeCloudPhonePushEnter              = @"push_云手机";
NSString *const ClickButtonTypeCloudPhonePushSwitch             = @"push_function_切换设备";
NSString *const ClickButtonTypeCloudPhonePushScreenShot         = @"push_function_截图";
NSString *const ClickButtonTypeCloudPhonePushShortcut           = @"push_function_添加桌面";
NSString *const ClickButtonTypeCloudPhonePushExit               = @"push_function_退出";

#pragma mark HWTopView-按钮
NSString *const ClickButtonTypeCloudPhoneBuyBtnClick           = @"buy_购买";
NSString *const ClickButtonTypeCloudPhoneListBtnClick          = @"list_列表";

#pragma mark 云盘
NSString *const ClickButtonTypeCloudStoreClickRenew         = @"cloud disk_续费入口";
NSString *const ClickButtonTypeCloudStoreContact            = @"cloud disk_通讯录";
NSString *const ClickButtonTypeCloudStoreUploadFile         = @"cloud disk_上传文件";
NSString *const ClickButtonTypeCloudStoreAddStoreClick      = @"cloud disk_去扩容";
NSString *const ClickButtonTypeCloudStoreAddStoreCancel     = @"cloud disk_去扩容_取消";
NSString *const ClickButtonTypeCloudStoreCreatDirectory     = @"cloud disk_新建目录";
NSString *const ClickButtonTypeCloudStoreTransferList       = @"cloud disk_传输列表";
NSString *const ClickButtonTypeCloudStoreUploadList         = @"cloud disk_上传列表";
NSString *const ClickButtonTypeCloudStoreDownloadList       = @"cloud disk_下载列表";
NSString *const ClickButtonTypeCloudStoreBrowser            = @"cloud disk_最近浏览";
NSString *const ClickButtonTypeCloudStoreSearch             = @"cloud disk_搜索功能";
NSString *const ClickButtonTypeCloudStoreFunction           = @"cloud disk_云盘功能键";

#pragma mark 我的
NSString *const ClickButtonTypeMineInfo                   = @"Personal_编辑";
NSString *const ClickButtonTypeMineInfoClickPhone         = @"Personal_phone_手机号";
NSString *const ClickButtonTypeMineInfoInputPhone         = @"Personal_phone_输入手机号";
NSString *const ClickButtonTypeMineInfoClickSMS           = @"Personal_phone_获取验证码";
NSString *const ClickButtonTypeMineInfoInputSMS           = @"Personal_phone_输入验证码";

NSString *const ClickButtonTypeMineStarCoin               = @"Personal_星币";
NSString *const ClickButtonTypeMineCoupon                 = @"Personal_卡券";
NSString *const ClickButtonTypeMineCouponUse              = @"Personal_coupon_去使用";
NSString *const ClickButtonTypeMineClickCoupon            = @"Personal_Card_优惠券";
NSString *const ClickButtonTypeMineClickActiveCode        = @"Personal_Card_激活码";
NSString *const ClickButtonTypeMineActiveCodeUse          = @"Personal_Card_去使用";

NSString *const ClickButtonTypeMineCustomerCenter         = @"Personal_客服中心";
NSString *const ClickButtonTypeMineActiveCode             = @"Personal_激活码";
NSString *const ClickButtonTypeMineToolCenter             = @"Personal_工具中心";
NSString *const ClickButtonTypeMineMessageCenter          = @"Personal_消息中心";
NSString *const ClickButtonTypeMineAuthorCenter           = @"Personal_授权中心";
NSString *const ClickButtonTypeMineOrderRecord            = @"Personal_购买记录";
NSString *const ClickButtonTypeMineCloudPhoneService      = @"Personal_云机服务";
NSString *const ClickButtonTypeMineFriend                 = @"Personal_好友";
NSString *const ClickButtonTypeMineSystemSet              = @"Personal_系统设置";

#pragma mark 问题反馈
NSString *const ClickButtonTypeCustomerCenterFeedback          = @"Personal_Customer_在线客服";
NSString *const ClickButtonTypeCustomerCenterNormal            = @"Personal_Customer_常见问题";
NSString *const ClickButtonTypeCustomerCenterQQ                = @"Personal_Customer_QQ客服";
NSString *const ClickButtonTypeCustomerCenterQQqun             = @"Personal_Customer_QQ群";
NSString *const ClickButtonTypeCustomerCenterPhone             = @"Personal_Customer_客服热线";

#pragma mark 激活码
NSString *const ClickButtonTypeActiveCodeTextField         = @"Personal_active code_激活码兑换";
NSString *const ClickButtonTypeActiveCodeExchange          = @"Personal_active code_兑换";

#pragma mark 工具中心
NSString *const ClickButtonTypeToolCenterAutoRenew         = @"Personal_tool center_自动续费管理";
NSString *const ClickButtonTypeToolCenterNetwork           = @"Personal_tool center_网络测速";

#pragma mark 授权管理
NSString *const ClickButtonTypeAuthorSet         = @"Personal_authorize_设置授权";
NSString *const ClickButtonTypeAuthorRecord      = @"Personal_authorize_授权记录";
NSString *const ClickButtonTypeAuthorSure        = @"Personal_authorize_确认";
NSString *const ClickButtonTypeAuthorBindPhone   = @"Personal_authorize_立即绑定";
NSString *const ClickButtonTypeAuthorBindCancel  = @"Personal_authorize_关闭";

#pragma mark 购买记录
NSString *const ClickButtonTypeOrderRecordCancel      = @"Personal_purchase record_取消订单按钮";
NSString *const ClickButtonTypeOrderRecordPay         = @"Personal_purchase record_去⽀付";

#pragma mark 好友
NSString *const ClickButtonTypeFriendAdd         = @"Personal_firend_加好友";
NSString *const ClickButtonTypeFriendWX          = @"Personal_firend_微信好友";
NSString *const ClickButtonTypeFriendContact     = @"Personal_firend_通讯录好友";
NSString *const ClickButtonTypeFriendQQ          = @"Personal_firend_qq好友";
NSString *const ClickButtonTypeFriendSendPicture = @"Personal_firend_发送图片";
NSString *const ClickButtonTypeFriendSendVideo   = @"Personal_firend_发送小视频";
NSString *const ClickButtonTypeFriendSendFile    = @"Personal_firend_发送文件";
NSString *const ClickButtonTypeFriendAuthPhone   = @"Personal_firend_授权云手机";
NSString *const ClickButtonTypeFriendBindPhone   = @"Personal_firend_立即绑定";
NSString *const ClickButtonTypeFriendBindCancel  = @"Personal_firend_关闭";

#pragma mark 系统设置
NSString *const ClickButtonTypeSystemSetChangePWD              = @"Personal_System setting_修改密码";
NSString *const ClickButtonTypeSystemSetDestroyAccount         = @"Personal_System setting_注销账号";
NSString *const ClickButtonTypeSystemSetExchangeAccount        = @"Personal_System setting_切换账号";
NSString *const ClickButtonTypeSystemSetLogout                 = @"Personal_System setting_退出登录账号";
NSString *const ClickButtonTypeSystemSetBack                   = @"Personal_System setting_返回";

#pragma mark 广告
NSString *const ClickButtonTypeADNoTipsToday                   = @"ad_当日不在提示";
NSString *const ClickButtonTypeADNoTips                        = @"ad_不在提示";
NSString *const ClickButtonTypeADClickBtn                      = @"ad_广告点击";
NSString *const ClickButtonTypeADClickAD                       = @"ad_活动点击";
NSString *const ClickButtonTypeADClose                         = @"ad_关闭广告";

#pragma mark 应用推荐
NSString *const ClickButtonTypeAppDownLoad                     = @"application_下载";
NSString *const ClickButtonTypeAppExchangeOther                = @"application_换一批";
NSString *const ClickButtonTypeAppRemindClosed                 = @"application_关闭";

#pragma mark 计时埋点
NSString *const ClickButtonTypeTimeCount                       = @"time_关闭此提醒";

#pragma mark 推流事件
NSString *const ClickButtonTypeChangePhone                     = @"push_function_切换设备";
NSString *const ClickButtonTypeScreenShot                      = @"push_function_截图";
NSString *const ClickButtonTypeAddDesk                         = @"push_function_添加桌面";
NSString *const ClickButtonTypeExitPhone                       = @"push_function_退出";
NSString *const ClickButtonTypeExitAndClosePhone               = @"push_function_退出并下线";

NSString *const ClickButtonTypeResolution                      = @"push_function_切换清晰度";
NSString *const ClickButtonTypeSysResloution                   = @"push_function_切换分辨率";
NSString *const ClickButtonTypeConnectModel                    = @"push_function_切换连接模式";
NSString *const ClickButtonTypeCopy                            = @"push_function_剪切板";
NSString *const ClickButtonTypeVR                              = @"push_function_虚拟键";
NSString *const ClickButtonTypeLeftModel                       = @"push_function_左手";
NSString *const ClickButtonTypeRootKey                         = @"push_function_ROOT开关";

#pragma mark 购买云机
NSString *const ClickButtonTypeBuyRedsTime                     = @"tuiliu_续时长";

#pragma mark 游客模式
NSString *const ClickButtonTypeVisitorModelInPhone             = @"window_进入云机";
NSString *const ClickButtonTypeVisitorModelInPhoneBind         = @"window_进入云机_立即绑定";
NSString *const ClickButtonTypeVisitorModelInPhoneCancel       = @"window_进入云机_关闭";
NSString *const ClickButtonTypeVisitorModelExtention           = @"window_拓展服务";
NSString *const ClickButtonTypeVisitorModelExtentionBind       = @"window_拓展服务_立即绑定";
NSString *const ClickButtonTypeVisitorModelExtentionCancel     = @"window_拓展服务_关闭";

NSString *const ClickButtonTypeVisitorModelListInPhone         = @"list_进入云机";
NSString *const ClickButtonTypeVisitorModelListInPhoneBind     = @"list_进入云机_立即绑定";
NSString *const ClickButtonTypeVisitorModelListInPhoneCancel   = @"list_进入云机_关闭";
NSString *const ClickButtonTypeVisitorModelListExtention       = @"list_拓展服务";
NSString *const ClickButtonTypeVisitorModelListExtentionBind   = @"list_拓展服务_立即绑定";
NSString *const ClickButtonTypeVisitorModelListExtentionCancel = @"list_拓展服务_关闭";

NSString *const ClickButtonTypeVisitorModelWelFareBind         = @"community_游戏福利_立即绑定";
NSString *const ClickButtonTypeVisitorModelWelFareCancel       = @"community_游戏福利_关闭";
NSString *const ClickButtonTypeVisitorModelWelFareBuyPhone     = @"community_游戏福利_购买云机";

/*20221207*/
NSString *const ClickButtonTypeVisitorModelExchangeBind     = @"Cloudphone_续费_立即绑定";
NSString *const ClickButtonTypeVisitorModelExchangeCancel   = @"Cloudphone_续费_关闭";

NSString *const ClickButtonTypeVisitorModelExchangeYearCardBind     = @"Cloudphone_续费年卡_立即绑定";
NSString *const ClickButtonTypeVisitorModelExchangeYearCardCancel   = @"Cloudphone_续费年卡_关闭";

NSString *const ClickButtonTypeVisitorModelExchangeStoreBind     = @"cloud disk_续费_立即绑定";
NSString *const ClickButtonTypeVisitorModelExchangeStoreCancel   = @"cloud disk_续费_关闭";

NSString *const ClickButtonTypeVisitorModelBuyPhoneBind     = @"buy_云手机_立即绑定";
NSString *const ClickButtonTypeVisitorModelBuyPhoneCancel   = @"buy_云手机_关闭";

NSString *const ClickButtonTypeVisitorModelBuyStoreBind     = @"buy_云盘_立即绑定";
NSString *const ClickButtonTypeVisitorModelBuyStoreCancel   = @"buy_云盘_关闭";

NSString *const ClickButtonTypeVisitorModelBuyServerBind     = @"buy_云机服务_立即绑定";
NSString *const ClickButtonTypeVisitorModelBuyServerCancel   = @"buy_云机服务_关闭";

NSString *const ClickButtonTypeVisitorModelBuyYearCardBind     = @"buy_特权年卡_立即绑定";
NSString *const ClickButtonTypeVisitorModelBuyYearCardCancel   = @"buy_特权年卡_关闭";

NSString *const ClickButtonTypeVisitorModelBuyStarCoinBind     = @"buy_星币_立即绑定";
NSString *const ClickButtonTypeVisitorModelBuyStarCoinCancel   = @"buy_星币_关闭";

NSString *const ClickButtonTypeVisitorModelActiveExchangeBind     = @"Personal_active code_立即绑定";
NSString *const ClickButtonTypeVisitorModelActiveExchangeCancel   = @"Personal_active code_关闭";
/*20221207*/

#pragma mark 福利社区
NSString *const ClickButtonTypeWelFareGFZX                     = @"community_官方资讯";
NSString *const ClickButtonTypeWelFareYXFL                     = @"community_游戏福利";

NSString *const ClickButtonTypeVisitorlginRegister              = @"Login_注册";
NSString *const ClickButtonTypeVisitorlginPhoneLogin            = @"Login_手机号登录";
NSString *const ClickButtonTypeVisitorlginLogin                 = @"Login_游客模式登录";
NSString *const ClickButtonTypeVisitorlginAccountLogin          = @"Login_账号登录";
NSString *const ClickButtonTypeVisitorlginLoginWX               = @"Login_微信登录";
NSString *const ClickButtonTypeVisitorlginLoginQQ               = @"Login_QQ登录";

@implementation HWBuryPointModel

#pragma mark - 埋点model构造方法
/**埋点model构造方法*/
+ (HWBuryPointModel *)buryPointWithEventType:(EventCodeType)eventCodeType buttonType:(ClickButtonType)clickButtonType {
    
    HWBuryPointModel *model = [[HWBuryPointModel alloc] init];
    model.client = @"2";
    model.eventCode = eventCodeType;
    model.eventResult = @"1";
    model.positionButton = clickButtonType;
    model.positionPage = @"";
    model.model = [iPhone phoneDeviceType];
    model.operationTime = [iTools getNowTimeString2];
    model.systemVersion = [iPhone phoneVersion];
    model.version = [NSBundle mainBundle].infoDictionary[@"CFBundleShortVersionString"];
    
    NSDictionary *dictLogin = [[UseAccountManage shareInstance] getLoginInfo];
    if (dictLogin && [[dictLogin allKeys] containsObject:@"userName"]) {
        model.userName = [dictLogin objectForKey:@"userName"];
    }else {
        model.userName = @"";
    }
    
    model.deviceId = [iPhone phoneDeviceUuid];
    model.ip = [iPhone phoneDeviceIPAddress];
    
    NSString *account = [HWDataManager getStringWithKey:Const_HWAccountPhoneNumber];
    if (account){
        model.phoneNumber = account;
    }
    
    return model;
}

/**埋点model构造方法*/
+ (HWBuryPointModel *)buryPointWithEventType:(EventCodeType)eventCodeType adPlaceID:(NSInteger)adPlaceID adID:(NSString *)adID {
    
    HWBuryPointModel *model = [[HWBuryPointModel alloc] init];
    model.client = @"2";
    model.eventCode = eventCodeType;
    model.eventResult = @"1";
    model.positionButton = [NSString stringWithFormat:@"广告点击_%ld_%@", adPlaceID, adID];
    model.positionPage = @"";
    model.model = [iPhone phoneDeviceType];
    model.operationTime = [iTools getNowTimeString2];
    model.systemVersion = [iPhone phoneVersion];
    model.version = [NSBundle mainBundle].infoDictionary[@"CFBundleShortVersionString"];
    
    NSDictionary *dictLogin = [[UseAccountManage shareInstance] getLoginInfo];
    if (dictLogin && [[dictLogin allKeys] containsObject:@"userName"]) {
        model.userName = [dictLogin objectForKey:@"userName"];
    }else {
        model.userName = @"";
    }
    
    model.deviceId = [iPhone phoneDeviceUuid];
    model.ip = [iPhone phoneDeviceIPAddress];
    
    NSString *account = [HWDataManager getStringWithKey:Const_HWAccountPhoneNumber];
    if (account){
        model.phoneNumber = account;
    }
    
    return model;
}

@end
