//
//  VclCrash.h
//  VclCrash
//
//  Created by Felix on 2018/8/10.
//  Copyright © 2018年 Felix. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "VclLog.h"

#ifdef Debug
#define VclWrite(content) [[VclCrash sharedInstance] writeContent:content]
#else
#define VclWrite(...)
#endif

/**
 1.当应用程序崩溃时，VclCrash会保存本次奔溃的信息到~/Library/Caches/VclCrash/JoyLite/Reports/...目录下；
 
 2.应用程序每次的启动，都会新创建一个文件，用于记录用户本次的操作、或者崩溃信息，命名如：log_2018.08.14.18_46_19.0190_ios.txt；
 
 3.规定单个文件不能超过1024KB，当超过1024KB时应需要新建文件；
 
 4.应用程序每次启动，都会检查除本次启动新建的文件外的所有日志文件名称，而且需要上传这些文件，根据上传返回的结果，上传成功的需要在本地删除掉
 未上传成功的，暂不删除，待下次启动时再做上传处理。
 */
@interface VclCrash : NSObject <NSCopying>

+ (instancetype)sharedInstance;

/**
 1.设置异常监听
 要想实现监听crash信息，此方法必须调用
 */
- (void)setDefaultUncaughtExceptionHandler;

/// 向crash.txt文件写入content信息，会自动换行
- (void)writeContent:(NSString *)content;

@end
